// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO
// Assumptions
// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO
//
// - 24-bit images have an even width
// - Sprite width/height cannot be more than 2x the image w/h (disregarding scalex/y)
// - Sprites are max 256x256
// - Nothing depends on the size of GsSPRITE structure.  I added elements to it.
//
// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO
// Porting "Gotchas"
// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO
//
// - rand() function is 15-bits on Yaroze, but 32-bits on NUON
//

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <math.h>
//#include "c:\nuonsdk\vmlabs\include\math.h"
#include <nuon/bios.h>
#include <nuon/dma.h>
#ifdef LIBSPRITE_INLINE
#include <nuon/intr.h>
#include "sprite2.h"
#else
#include <nuon/sprite2.h>
#endif
#include "sprite2b.h"
#include <nuon/nise.h>
#include <nuon/video.h>
#include "perfmon.h"


#include <libps.h>
#include "../sauron/srn_psx.h"
#include <dsiCommon.h>
#include "yarlib.h"
#include "screenshot.h"

// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO
// DEFINES
// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO

#define MAX_CONTROLLERS 2

#define SPRITE_PRESCALE 0

#define MAX_OTS         MAX_DISPLAY_LISTS
#define MAX_FB          8

#define FUNC_TRACE      0
#define SHOW_UNIMPLEMENTED_FUNCTIONS 0

#define NOTE_C_4 0x40

#define LIBSPRITE_DEBUG 0

//#define USE_BORDERX  // don't use this since SPRSetOffset handles offsetting the sprites

enum {
  kEventVSync,
  kEventSwapDispBuff,
  kEventDrawOT,
  kEventDrawSyncStart,
  kEventDrawSyncEnd,
  kEventGetActiveBuff,
  kEventClearOT,
  kEventMax
};

char* aEventString[kEventMax] = {
  "VSync()",
  "GsSwapDispBuff()",
  "GsDrawOT()",
  "DrawSync() start",
  "DrawSync() end",
  "GsGetActiveBuff()",
  "GsClearOT()",
};

// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO
//
// Global variables
//
// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO

RECT CLIP2;		/* clipping area */
int GsLIGHT_MODE;	/* lighting mode global */
short PSDOFSX[2], PSDOFSY[2];	/* double buffer base */
short PSDIDX;		/* double buffer index */
u_long PSDCNT;		/* frame counter for using matrix cache */
_GsPOSITION POSITION;	/* 2d offset */
DRAWENV GsDRAWENV;	/* DRAWENV of Gs */
DISPENV GsDISPENV;	/* DISPENV of Gs */
MATRIX GsLSMATRIX;	/* Local-Screen Matrix of Gs */
MATRIX GsWSMATRIX;	/* Current World-Screen Matrix of Gs */
MATRIX GsLIGHTWSMATRIX;	/* World-Screen Light Matrix of Gs */
MATRIX GsIDMATRIX;	/* Unit Matrix */
MATRIX GsIDMATRIX2;	/* Unit Matrix including Aspect retio */
PACKET *GsOUT_PACKET_P;	/* Work Base pointer */
u_long GsLMODE, GsLIGNR, GsLIOFF, GsNDIV;
u_long GsTON, GsDISPON;

int math_errno;

int yarlibDebug      = 0;
int yarlibMemDebug   = 0;
int libSpriteHang    = 0;
int yarlibDebugParam = -1;

int screenFlash = 0;
int screenFade  = 0;

// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO
//
// Structures and variables needed by NUON
//
// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO

// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO
// CONSTANTS
// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO
#ifndef TRUE
#define TRUE   1
#endif
#ifndef FALSE
#define FALSE  0
#endif

enum {
  kImgFlagDirty        = (1<<0),  // image is dirty and needs to be regenerated
  kImgFlagNoPrescale   = (1<<1),  // image should not be prescaled when prescaling is active
  kImgFlagPrescale     = (1<<2),  // image should be prescaled all the time
  
  kImgFlagScaleMethod  = (3<<3),  // how to combine pixels when autoscaling
  kImgFlagScaleSimple  = (0<<3),  // pixel resize - last pixel wins
  kImgFlagScaleNoBlack = (1<<3),  // any non-black pixel wins
  kImgFlagScaleFilter  = (2<<3),  // combine all pixels evenly

  // Don't use bit 6 - it's used by GsSPRITE
  
  kImgFlagBakeRGB      = (1<<7),  // generate images in RGB color space
  
  kImgFlagNoTranslucent= (1<<9),  // do not allow translucent pixels

  kImgFlagUseDirect    = (1<<10), // set if the image should be used directly from memory, rather
                                  // than generated based on the simulated Yaroze VRAM

  kImgFlagFeedback     = (1<<12), // set if this sprite's source image is taken from the previous
                                  // video frame
  kImgFlagBakeYCrCb    = (1<<13), // bake in the RGB brightness, but keep pixels in YCrCb
  kImgFlagPermImage    = (1<<20), // never deallocate this image
  kImgFlagSticky       = (1<<22), // do not deallocate this image until it un-stickifies
} eImgFlag;

// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO
// STRUCTS
// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO

struct sClutTag {
  unsigned long cxcycw;  // CX[31:20],CY[19:8],CW[7:0]
  unsigned long tpages;  // bitfield indicating what tpages contain images that use this clut
  struct sClutTag *next;
};

typedef struct sClutTag sClut;

typedef struct {
  int            x, y;  // coordinates in Yaroze VRAM
  int            w, h;  // dimensions in Yaroze VRAM (ignoring any additional border)
  void          *ptr;   // pointer to buffer
  sImage         img;   // image for feedback
  SPR_IMAGE_INFO spr;   // sprite for feedback
} sFB;

// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO
// GLOBALS
// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO

// Video stuff
VidDisplay vd;
VidChannel vcYar;
VidChannel vcOther;
VidChannel *vcMain = NULL;
VidChannel *vcOSD  = NULL;
int yarChannel;
int otherChannel = -1;
int vcOtherActive = FALSE;
int vcOtherRender = FALSE;
int vcOtherW = -1, vcOtherH = -1;

int numFB = DOUBLE_BUFFER;
//void *frameBuffer[MAX_FB] = { NULL, NULL, NULL };
sFB aFB[MAX_FB];
void *otherBuffer = NULL;
int aFBIndex[QUAD_BUFFER] = { 0, 1, 2, 3 };

// Side buffer (for Invs)
int sideRender = FALSE;
int sideBufferW = -1, sideBufferH = -1;
sFB sideBuffer;

void *screenshotBuffer;
int screenW, screenW16, screenH;
int bufferW, bufferH;
int borderX;
int dispScale = 0;

#define FRAMERATE_PATTERN_SIZE 2
#define FRAMERATE_PATTERN_MASK ( ( 1 << FRAMERATE_PATTERN_SIZE ) - 1 )
int maxFrameRate = 60;
unsigned long frameRatePatternOrig;
unsigned long frameRatePatternCur;

volatile int dispBuffer, drawBuffer, prevBuffer;
int buffReady = 0;
int buffDisp  = 0;
int clrScreen = FALSE;
static int clrMethod, clrParam1, clrParam2, clrParam3;
volatile int lastfps;
int _frame = 0;
long extraTime = 0;
long flagsSpriteLib = 0;

#define YAROZE_VRAM_WIDTH 1024
#define YAROZE_DMA_FLAGS_WR  (DMA_PIXEL_WRITE | ((YAROZE_VRAM_WIDTH/8)<<16) | (1<<11) | (2<<4))
#define YAROZE_DMA_FLAGS_WR2 (DMA_PIXEL_WRITE | ((YAROZE_VRAM_WIDTH/8)<<16) | (1<<11) | (8<<4))
#define YAROZE_DMA_FLAGS_RD  (DMA_PIXEL_READ  | ((YAROZE_VRAM_WIDTH/8)<<16) | (1<<11) | (2<<4))
#define YAROZE_DMA_FLAGS_RD2 (DMA_PIXEL_READ  | ((YAROZE_VRAM_WIDTH/8)<<16) | (1<<11) | (8<<4))
int dmaFlagsRd = 0, dmaFlagsWr = 0;

#define BUFFER_MODE_16BIT 0
#define BUFFER_MODE_24BIT 1
int bufferMode;

#define IMG_DEALLOC_LIMIT  2000000 // # of bytes of image space after which to start deallocating
#define IMG_DEALLOC_THRESH 120     // # frames above which we shouldn't dealloc an image
int totalImgAlloc = 0;
int maxTotalImgAlloc = 0;

#define CLUSTER_WIDTH_LIMIT 512
#define NUM_TPAGES 32
#define DIRECT NUM_TPAGES
sImage* aImage[NUM_TPAGES + 1];  // One pointer for each tpage plus one for direct images
sClut*  aClut [NUM_TPAGES];
sImage* freeImages = NULL;

#define MAX_SPRITES 512
SPRITE *aSprite[MAX_SPRITES];
int numSprites = 0;

PadBits yarPad[MAX_CONTROLLERS];  // NUON controller structure
int curButtons, prevButtons;

void *yarozeBuff = NULL;    // Yaroze video RAM
char *localScratch = NULL;  // Local RAM
int localSize;

static SPR_IMAGE_INFO constWhiteImg;

sSndMap *aSndMap = NULL;

#define VID_NTSC 1
#define VID_PAL  2
int videoStandard = 0;

GsOT *aOT[MAX_OTS];  // an array of OT pointers

static int gotBiosInfo = 0;
static struct BiosInfo *bi;
int devSystem = FALSE;

typedef enum {
  kCheckpointsOff,
  kCheckpointsWorst,
  kCheckpointsAvg,
  kCheckpointsViolate,
  kCheckpointsMax,
} eCheckpoints;

char* aCheckpointsDesc[] = {
  "OFF",
  "WORST",
  "AVERAGE",
  "VIOLATING",
};

static eCheckpoints showCheckpoints = kCheckpointsOff;
static int showFramerate = 0;

char strToPrint[100] = { 0 };

// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO
//
// Sprite library (if inlined)
// Must come before other functions otherwise inlining won't work.
//
// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO

#ifdef LIBSPRITE_INLINE
#include "..\libsprite\libsprite.c"
#endif

// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO
//
// Local functions
//
// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO

int         getFrameRatePattern(int targetFrameRate);
int         getNewFrameBuffer(int w, int h, int x, int y);
void        allocateFrameBuffers(int w, int h, int x0, int y0, int x1, int y1);
void        readControllers ();
void        checkOverlap    (int x, int y, int w, int h);
int         getOptimalH     (RECT *rect, int y, int maxPix, int scaleH);
int         getOptimalW     (RECT *rect, int x, int maxPix, int h, int bppShift);
void        copyYarozeToFB  (RECT *rect, sFB *fb);
void        rgb2ycrcb       (unsigned char *in_r, unsigned char *in_g,  unsigned char *in_b );
void        ycrcb2rgb       (unsigned char *in_y, unsigned char *in_cr, unsigned char *in_cb);
void        screenshotCheck (int w, int h, int dmaFlags);
SPRITE*     getNUONSprite      (GsSPRITE *sp, sImage *img, GsOT *ot, int pri, int fastSprite);
SPRITE*     getNUONSpriteNoRotate(GsSPRITE *sp, sImage *img, GsOT *ot, int pri, int fastSprite);
SPRITE*     getNUONSpriteSimple(GsSPRITE *sp, sImage *img, GsOT *ot, int pri, int fastSprite);
SPRITE*     getNUONLine     (GsLINE *line, SPR_IMAGE_INFO *info, GsOT *ot, int pri);
SPRITE*     getNUONBox      (GsBOXF *box,  SPR_IMAGE_INFO *info, GsOT *ot, int pri);
void        resetNUONSprites();
sImage*     allocImage      (GsSPRITE *sp);
void*       allocImageData  (GsSPRITE *sp, SPR_IMAGE_INFO *info);
void        crcLinear       (void *addr, int numBytes, char *str, int print);
void        yarCRCBilinear  (void *addr, int x, int y, int w, int h, int buffW_in,
			     int print, char *string);
void        generateImage   (int tpage, sImage *img);
void        YarFillBuffer   (int x, int y, int w, int h, int color);
void        YarFillRect     (int initx, int inity, int wide, int high, int color, int bufIndex);
int         PlayWAV         (void *wavaddr, int loop, PCMPOS *Pan, int volume, int note);
int         myVSync         (int mode);
void        intVSync        ();

// =================================================================================================

void yarozeInit( int frameRate, sSndMap *sndMap, int channel, int numFB_in, int flags )
{
  static int init = 0;
  int *ptr;
  int x, y;
  int i;
  VidDisplay vd;
  int debug = FUNC_TRACE;

  if ( debug != 0 )
  {
    printf( "YARLIB %s(frameRate=%d, sndMap=%08X, channel=%d, numFB_in=%d, flags=%d)\n",
	    __func__, frameRate, sndMap, channel, numFB_in, flags );
  }
  
  // Ensure this only gets done once
  if ( init != 0 )
  {
    return;
  }
  init = 1;

  //  dsiInitDebugFB();

  if ( gotBiosInfo == 0 )
  {
    bi = _BiosGetInfo();
    gotBiosInfo = 1;
    if ( strcmp(bi->date_string, "Sep 19 2001" ) == 0 )
    {
      devSystem = TRUE;
    }
  }

  videoStandard = _VidQueryConfig(&vd);

  flagsSpriteLib = flags;

  numFB = numFB_in;

  /*
    maxFrameRate = MAXFRAMERATE_60FPS;
    if ( frameRate == MAXFRAMERATE_30FPS)
{
    maxFrameRate = frameRate;
    }
  */
  maxFrameRate = frameRate;
  maxFrameRate = getFrameRatePattern( maxFrameRate );
  frameRatePatternCur = frameRatePatternOrig;

  // Set the array that maps from VAB to WAV
  AUDIOInit();
  aSndMap = sndMap;
  if ( aSndMap != NULL )
  {
    for (i = 0; aSndMap[i].vb; i++)
    {
      aSndMap[i].vabID = -1;
    }
  }

  // Set up the channel that the yaroze will use to display
  assert((channel == VID_CHANNEL_MAIN) || (channel == VID_CHANNEL_OSD));
  yarChannel = channel;
    
  //    for (i = 0, ptr = (int *) 0x40000000; i < (0x800000 >> 2); i++, ptr++)
  //      *ptr = 0;

  // Yaroze video buffer is 1024x512x16bpp
  // On NUON we use 32bpp to make life easier
  yarozeBuff = _MemAlloc(1024 * 512 * 4, 512, kMemSDRAM);

  localScratch = _MemLocalScratch(&localSize);

  // Initialize array that holds Yaroze-to-NUON image conversion
  for ( i = 0; i < NUM_TPAGES; i++ )
  {
    aImage[i] = NULL;
    aClut [i] = NULL;
  }

  // Allocate at most three worst-case (32bpp) buffers
  //    for(i = 0; i < numFB; i++) frameBuffer[i] = _MemAlloc(720 * 480 * 4, 512, kMemSDRAM);
  //    for(i = 0; i < numFB; i++) frameBuffer[i] = _MemAlloc(360 * 240 * 4, 512, kMemSDRAM);

  //    InitTerminalX(1, (int)frameBuffer[0], 320, 240,
  //		  (DMA_PIXEL_WRITE | ((320/8)<<16) | (4<<4) | (1<<11)), 0);

  if ( strncmp(bi->info_string, "Nuance", strlen( "Nuance" ) ) == 0 )
  {
    printf("Emulator detected\n");
    SPRInit(0x2, 240, SPR_FLAG_ADD_REVERSE | SPR_FLAG_DOUBLE_BUFFER | SPR_FLAG_CLEAR_FAST | flags);
  }
  else
  {
    // Slice height must divide into screen height evenly or else the clear routine breaks
    SPRInit(0x7, 32, SPR_FLAG_ADD_REVERSE | SPR_FLAG_DOUBLE_BUFFER | SPR_FLAG_CLEAR_FAST | flags);
    //    SPRInit(0x2, 256, SPR_FLAG_ADD_REVERSE | SPR_FLAG_DOUBLE_BUFFER | SPR_FLAG_CLEAR_FAST | flags);
  }

  // Indices into frame buffer array
  dispBuffer = 0;
  drawBuffer = 1;
  prevBuffer = 0;

  //
  // Initialize image of constant color (for boxes & lines)
  //
  constWhiteImg.width  = 128;  // make sure we can cover the whole screen
  constWhiteImg.height = 128;
  constWhiteImg.dmaflags = ( ( ( constWhiteImg.width / 8 ) << 16 ) | ( 4 << 4 ) | DMA_PIXEL_READ );
  constWhiteImg.img = _MemAlloc(constWhiteImg.width * constWhiteImg.height * 4, 512, kMemSDRAM);

  // Check if we got the memory
  if ( constWhiteImg.img == NULL )
  {
    printf("ERROR: Failed to malloc 'constWhiteImg.img'\n");  fflush(stdout);
    exit(1);
  }

  // Fill the pixels with white
  for ( x = 0; x < constWhiteImg.width; x += 8 )
  {
    for ( y = 0; y < constWhiteImg.height; y += 8 )
    {
      _DMABiLinear(((constWhiteImg.width/8)<<16) | (4<<4) | DMA_PIXEL_WRITE | DMA_DIRECT_BIT,
		   constWhiteImg.img, (8<<16)|x, (8<<16)|y, (void *) (YCrCb32_WHITE | 0x01));
    }
  }

  // Initialize the side buffer
  sideBuffer.ptr = NULL;
  
  //
  // Install the screen shot handler
  //
  if ( devSystem == TRUE )
  {
    //    ssInstall( 0, JOY_L | JOY_R );
  }
  
  for ( i = 0; i < MAX_OTS; i++ )
  {
    aOT[i] = NULL;
  }
    
  for ( i = 0; i < MAX_FB; i++ )
  {
    aFB[i].ptr = NULL;
  }

}

// =================================================================================================

unsigned long * YarGetScratchAddr( int offset )
{
  return (unsigned long *) &localScratch[384+offset];
}

// =================================================================================================

int getFrameRatePattern( int targetFrameRate )
{
  int i;
  int numNibbles, actNibbles;
  int found = FALSE;
  int vidFrameRate = ( videoStandard == VID_NTSC ) ? 60 : 50;
  int numTicks, actTicks;
  double numTicksF;
  double actFrameRate = 0.0;
  double thisFrameRate;
  int prevTick;
  double thisTick;
  int debug = 0;

  if ( targetFrameRate == -1 )
  {
    // -1 selects max frame rate
    targetFrameRate = vidFrameRate;
  }
  else if ( targetFrameRate == -2)
  {
    // -2 selects max frame rate / 2
    targetFrameRate = vidFrameRate >> 1;
  }

  // Clamp frame rate
  if ( targetFrameRate < ( 60 / ( 1 << FRAMERATE_PATTERN_SIZE ) ) )
  {
    targetFrameRate = 60 / ( 1 << FRAMERATE_PATTERN_SIZE );
  }
  if ( targetFrameRate > vidFrameRate )
  {
    targetFrameRate = vidFrameRate;
  }

  // Number of ticks = (60 or 50) / (Target / number of nibbles)
  // Actual frame rate = (50 or 60) / numTicks * number of nibbles
  //  targetFrameRate = 47;
  if ( debug != 0 )
  {
    printf("Target framerate = %d\n", targetFrameRate);
  }

  for ( numNibbles = ( 32 / FRAMERATE_PATTERN_SIZE );
	numNibbles > ( 16 / FRAMERATE_PATTERN_SIZE );
	numNibbles-- ) { 
    numTicksF = (double) vidFrameRate / ( (double) targetFrameRate / (double) numNibbles );
    numTicks = (int) numTicksF;
    if ( ( numTicksF - (double) numTicks ) > 0.0 )
    {
      numTicks++;
    }
    thisFrameRate = ( (double) vidFrameRate / (double) numTicks ) * (double) numNibbles;

    if ( debug != 0 )
    {
      printf( "%d: numTicks=%d  thisFrameRate=%f\n", numNibbles, numTicks, thisFrameRate );
    }

    if ( thisFrameRate > actFrameRate )
    {
      actFrameRate = thisFrameRate;
      actTicks     = numTicks;
      actNibbles   = numNibbles;
    }
  }

  if ( debug != 0 )
  {
    printf( "Final:  numNibbles=%d  numTicks=%d  thisFrameRate=%f\n",
	    actNibbles, actTicks, actFrameRate );
  }

  frameRatePatternOrig = 0;
  for ( i = 0; i < actNibbles; i++ )
  {
    frameRatePatternOrig |= ( actTicks / actNibbles ) << ( FRAMERATE_PATTERN_SIZE * i );
    if ( debug != 0 )
    {
      printf( "frameRatePatternOrig=%08X\n", frameRatePatternOrig );
    }
  }
  actTicks = actTicks % actNibbles;
  numTicksF = (double) actTicks / (double) actNibbles;

  prevTick = -1;
  for ( i = 0, thisTick = 0.0; i < actNibbles; i++, thisTick += numTicksF )
  {
    if ( (int) thisTick != prevTick )
    {
      frameRatePatternOrig += 1 << ( FRAMERATE_PATTERN_SIZE * i );
      prevTick = (int) thisTick;
    }
    if ( debug != 0 )
    {
      printf( "%d: frameRatePatternOrig=%08X (%f,%f)\n",
	      i, frameRatePatternOrig, numTicksF, thisTick );
    }
  }

  if ( debug != 0 )
  {
    printf( "Final: frameRatePatternOrig=%08X\n", frameRatePatternOrig );
  }

  return (int) actFrameRate;
}

// =================================================================================================

int getNewFrameBuffer(int w, int h, int x, int y)
{
  int fbIndex;
  int debug = FUNC_TRACE;

  if ( debug != 0 ) printf("YARLIB %s(w=%d, h=%d, x=%d, y=%d)\n", __func__, w, h, x, y);
  
  for (fbIndex = 0; fbIndex < MAX_FB; fbIndex++) {
    if ( aFB[fbIndex].ptr == NULL) {
      break;
    }
  }

  if ( fbIndex >= MAX_FB) {
    printf("\nYARLIB ERROR in %s(): Ran out of room in aFB\n", __func__);
    while (1);
  }

  // Pixel mode is always 32-bit
  aFB[fbIndex].ptr = _MemAlloc(w * h * 4, 512, kMemSDRAM);
  if ( debug != 0 ) printf("YARLIB %s(): ptr=%08X\n", __func__, aFB[fbIndex].ptr);

  if ( !aFB[fbIndex].ptr) {
    printf("YARLIB ERROR in %s(): Failed to allocate frame buffer\n", __func__);
    while (1);
  }

  aFB[fbIndex].x = x;
  aFB[fbIndex].y = y;
  aFB[fbIndex].w = w - (borderX<<1);
  aFB[fbIndex].h = h;
  
  aFB[fbIndex].spr.width    = w;
  aFB[fbIndex].spr.height   = h;
  aFB[fbIndex].spr.dmaflags = ( ( w >> 3 ) << 16 ) | ( 4 << 4 ) | DMA_PIXEL_READ | ( 1 << 11 );
  aFB[fbIndex].spr.img      = aFB[fbIndex].ptr;
  
  aFB[fbIndex].img.flags = kImgFlagFeedback;
  aFB[fbIndex].img.info  = &aFB[fbIndex].spr;
/*
  // Fill the border pixels with black
  for (x = 0; x < borderX; x += 8) {
    for (y = 0; y < aFB[fbIndex].spr.height; y += 8) {
      _DMABiLinear(((aFB[fbIndex].spr.width/8)<<16) | (4<<4) | DMA_PIXEL_WRITE | DMA_DIRECT_BIT,
		   aFB[fbIndex].spr.img, (8<<16)|x, (8<<16)|y, (void *) (YCrCb32_BLACK | 0x01));
    }
  }
  for (x = borderX + aFB[fbIndex].spr.width; x < (borderX+aFB[fbIndex].spr.width+borderX); x += 8) {
    for (y = 0; y < aFB[fbIndex].spr.height; y += 8) {
      _DMABiLinear(((aFB[fbIndex].spr.width/8)<<16) | (4<<4) | DMA_PIXEL_WRITE | DMA_DIRECT_BIT,
		   aFB[fbIndex].spr.img, (8<<16)|x, (8<<16)|y, (void *) (YCrCb32_BLACK | 0x01));
    }
  }
*/
  // Copy initial pixels from Yaroze buffer to the frame buffer
  checkOverlap(x, y, w, h);
      
  //  fbAlloc++;

  return fbIndex;
}

// =================================================================================================

void* yarGetFBPtr()
{
  /*
  int buffIndex;
  
  // Look for a frame buffer matching the given parameters
  for (buffIndex = 0; buffIndex < MAX_FB; buffIndex++) {
    if ( (aFB[buffIndex].x == x) && (aFB[buffIndex].y == y)) {
      return aFB[buffIndex].ptr;
    }
  }
  
  return NULL;
  */

  return aFB[aFBIndex[drawBuffer]].ptr;
}

// =================================================================================================

void allocateFrameBuffers(int w, int h, int x0, int y0, int x1, int y1)
{
  static int prevW = -1, prevH = -1;
  int buffIndex;
  int debug = FUNC_TRACE;

  if ( ( w != prevW ) || ( h != prevH ) )
  {
    if ( debug != 0 ) printf("YARLIB %s(): w/h conflict -- old=%d,%d  new=%d,%d\n",
		      __func__, prevW, prevH, w, h);
    
    for ( buffIndex = 0; buffIndex < MAX_FB; buffIndex++ )
    {
      if ( aFB[buffIndex].ptr != NULL )
      {
	_MemFree(aFB[buffIndex].ptr);
	aFB[buffIndex].ptr = NULL;
      }
    }

    //    fbAlloc = 0;

    aFBIndex[0] = getNewFrameBuffer( w, h, x0, y0 );
    aFBIndex[1] = getNewFrameBuffer( w, h, x1, y1 );

    if ( debug != 0 ) printf("YARLIB %s(): new FB indices=%d,%d\n", __func__, aFBIndex[0], aFBIndex[1]);
    
    // Allocate two more buffers if we are quad buffering
    if ( numFB == QUAD_BUFFER )
    {
      aFBIndex[2] = getNewFrameBuffer( w, h, x0, y0 );
      aFBIndex[3] = getNewFrameBuffer( w, h, x1, y1 );
      if ( debug ) printf("YARLIB %s(): new FB indices=%d,%d\n", __func__, aFBIndex[2], aFBIndex[3]);
    }

    dispBuffer = 0;
    drawBuffer = 1;
    prevBuffer = 0;

    prevW = w;
    prevH = h;
  }
  else
  {
    // Dimensions didn't change so see if we already have frame buffers defined for
    // the given coordinates.

    // TODO: Deallocate any buffer that these overlap.

    //
    // Get buffer 0 (first), allocating a new one if necessary.
    //
    for ( buffIndex = 0; buffIndex < MAX_FB; buffIndex++ )
    {
      if ( ( aFB[buffIndex].x == x0 ) && ( aFB[buffIndex].y == y0 ) )
      {
	break;
      }
    }
    if ( buffIndex >= MAX_FB )
    {
      buffIndex = getNewFrameBuffer( w, h, x0, y0 );
      if ( debug != 0 ) printf("YARLIB %s(): new buffer(0)=%d  x0=%d y0=%d\n", __func__,
			buffIndex, x0, y0);
    }
    aFBIndex[0] = buffIndex;

    if ( numFB == QUAD_BUFFER )
    {
      //
      // Get buffer 0 (second), allocating a new one if necessary.
      //
      for (buffIndex++; buffIndex < MAX_FB; buffIndex++)
      {
	if ( ( aFB[buffIndex].x == x0 ) && ( aFB[buffIndex].y == y0 ) )
	{
	  break;
	}
      }
      if ( buffIndex >= MAX_FB )
      {
	buffIndex = getNewFrameBuffer( w, h, x0, y0 );
	if ( debug != 0 ) printf("YARLIB %s(): new buffer(0-2)=%d  x0=%d y0=%d\n", __func__,
			  buffIndex, x0, y0);
      }
      aFBIndex[2] = buffIndex;
    }
    
    //
    // Get buffer 1 (first), allocating a new one if necessary.
    //
    for ( buffIndex = 0; buffIndex < MAX_FB; buffIndex++ )
    {
      if ( ( aFB[buffIndex].x == x1 ) && ( aFB[buffIndex].y == y1 ) )
      {
	break;
      }
    }
    if ( buffIndex >= MAX_FB )
    {
      buffIndex = getNewFrameBuffer( w, h, x1, y1 );
      if ( debug != 0 ) printf("YARLIB %s(): new buffer(1)=%d  x1=%d  y1=%d\n", __func__,
			buffIndex, x1, y1);
    }
    aFBIndex[1] = buffIndex;

    if ( numFB == QUAD_BUFFER )
    {
      //
      // Get buffer 1 (second), allocating a new one if necessary.
      //
      for ( buffIndex++; buffIndex < MAX_FB; buffIndex++ )
      {
	if ( ( aFB[buffIndex].x == x1 ) && ( aFB[buffIndex].y == y1 ) )
	{
	  break;
	}
      }
      if ( buffIndex >= MAX_FB )
      {
	buffIndex = getNewFrameBuffer( w, h, x1, y1 );
	if ( debug != 0 ) printf("YARLIB %s(): new buffer(1-2)=%d  x1=%d  y1=%d\n", __func__,
			  buffIndex, x1, y1);
      }
      aFBIndex[3] = buffIndex;
    }
  }
  
  if ( debug != 0 ) printf("YARLIB %s(): drawBuffer=%d(FB=%d)  dispBuffer=%d(FB=%d)\n", __func__,
		    drawBuffer, aFBIndex[drawBuffer], dispBuffer, aFBIndex[dispBuffer]);
}

// =================================================================================================

// These are used to scale the analog values so that even the Logitech controller gets a full swing
int minX[MAX_CONTROLLERS] = {  127,  127 };
int maxX[MAX_CONTROLLERS] = { -128, -128 };
int minY[MAX_CONTROLLERS] = {  127,  127 };
int maxY[MAX_CONTROLLERS] = { -128, -128 };
int minXMult[MAX_CONTROLLERS] = { 0x100, 0x100 };  // init to 1 in 24.8 format
int maxXMult[MAX_CONTROLLERS] = { 0x100, 0x100 };
int minYMult[MAX_CONTROLLERS] = { 0x100, 0x100 };
int maxYMult[MAX_CONTROLLERS] = { 0x100, 0x100 };
int xMinCnt[MAX_CONTROLLERS] = { 0, 0 };
int xMaxCnt[MAX_CONTROLLERS] = { 0, 0 };
int yMinCnt[MAX_CONTROLLERS] = { 0, 0 };
int yMaxCnt[MAX_CONTROLLERS] = { 0, 0 };

int controllerBuffer[1024];
int controllerBuffer2[1024];
int controllerBuffer3[1024];
int head = 0, tail = 0;

void readControllers()
{
  int i;
  int nuonIndex;
  int xAxis, yAxis;
  int buttons;

  prevButtons = curButtons;
  curButtons = _Controller[1].buttons;

  // Can use this to trigger print statements while the game is running
  if ( devSystem && ( _Controller[1].buttons & JOY_NUON ) &&
      ( curButtons & JOY_L ) && ( ( prevButtons & JOY_L ) == 0 ) )
  {
    libspritePrintSprites = 1 - libspritePrintSprites;
    /*
    if ( libspritePrintSprites) {
      printf("-------------------------------------------------------------------------------\n");
    }
    */
  }
  
  for (i = 0; i < MAX_CONTROLLERS; i++) {
    nuonIndex = i + 1;
    if ( i == 1) {
      nuonIndex = 5;
    }

    // Check if controller has changed
    if ( _Controller[nuonIndex].changed) {
      _DeviceDetect(nuonIndex);
    }

    if ( !_Controller[nuonIndex].changed) {
      yarPad[i].data.IsActive = _Controller[nuonIndex].status ? 0 : 0xFF;

      //      if ( (i == 0) || _Controller[nuonIndex].status) {
      if ( 1 ) {

	if ( _Controller[nuonIndex].status) {
	  xAxis = _Controller[nuonIndex].d1.xAxis;
	  yAxis = _Controller[nuonIndex].d2.yAxis;
	  
	  if ( xAxis < -50) {
	    if ( xAxis < minX[i]) {
	      minX[i] = xAxis;
	      minXMult[i] = (-127<<8) / minX[i];
	    } else {
	      xMinCnt[i]++;
	      if ( xMinCnt[i] > 30) {
		xMinCnt[i] = 0;
		if ( minX[i] < 0) {
		  minX[i]++;
		  minXMult[i] = (-127<<8) / minX[i];
		}
	      }
	    }
	  }
	
	  if ( i == 0) {
	    if ( ((head + 1) != tail) && ((head != 1023) || (tail != 0))) {
	      controllerBuffer[head]  = minX[i];
	      head++;
	      if ( head > 1023) head = 0;
	    }
	  }

	  if ( xAxis > 50) {
	    if ( xAxis > maxX[i]) {
	      maxX[i] = xAxis;
	      maxXMult[i] = (126<<8) / maxX[i];
	    } else {
	      xMaxCnt[i]++;
	      if ( xMaxCnt[i] > 30) {
		xMaxCnt[i] = 0;
		if ( maxX[i] < 0) {
		  maxX[i]++;
		  maxXMult[i] = (-127<<8) / maxX[i];
		}
	      }
	    }
	  }
	
	  if ( yAxis < -50) {
	    if ( yAxis < minY[i]) {
	      minY[i] = yAxis;
	      minYMult[i] = (-127<<8) / minY[i];
	    } else {
	      yMinCnt[i]++;
	      if ( yMinCnt[i] > 30) {
		yMinCnt[i] = 0;
		if ( minY[i] < 0) {
		  minY[i]++;
		  minYMult[i] = (-127<<8) / minY[i];
		}
	      }
	    }
	  }
	  
	  if ( yAxis > 50) {
	    if ( yAxis > maxY[i]) {
	      maxY[i] = yAxis;
	      maxYMult[i] = (126<<8) / maxY[i];
	    } else {
	      yMaxCnt[i]++;
	      if ( yMaxCnt[i] > 30) {
		yMaxCnt[i] = 0;
		if ( maxY[i] < 0) {
		  maxY[i]++;
		  maxYMult[i] = (-127<<8) / maxY[i];
		}
	      }
	    }
	  }
	}

	buttons = 0;
	if ( _Controller[nuonIndex].status) {
	  buttons |= _Controller[nuonIndex].buttons;
	}
	if ( i == 0) {
	  buttons |= _Controller[0].buttons;
	}
	//	printf("buttons=%08X\n", buttons);

	// Analog controllers look like a dual shock and everything else is a digital pad.
	// We force the second stick to never move so we have to hope the games don't use it.
	// We also don't have the L3/R3 buttons, but those are rarely used anyway.
	if ( _Controller[nuonIndex].properties & CTRLR_ANALOG1) {
	  yarPad[i].data.DataHalfSize = 3;
	  yarPad[i].data.DevType      = DEVTYPE_ANALOG_PAD;
	} else {
	  yarPad[i].data.DataHalfSize = 1;
	  yarPad[i].data.DevType      = DEVTYPE_DIGITAL;
	}
	yarPad[i].data.Select       = (buttons & JOY_NUON ) ? 0 : 1;
	yarPad[i].data.Start        = (buttons & JOY_START) ? 0 : 1;
	yarPad[i].data.L1           = (buttons & JOY_L    ) ? 0 : 1;
	yarPad[i].data.R1           = (buttons & JOY_R    ) ? 0 : 1;
	yarPad[i].data.L3           = 1;  // ...
	yarPad[i].data.R3           = 1;  // ...
	yarPad[i].data.Up           = (buttons & JOY_UP   ) ? 0 : 1;
	yarPad[i].data.Right        = (buttons & JOY_RIGHT) ? 0 : 1;
	yarPad[i].data.Down         = (buttons & JOY_DOWN ) ? 0 : 1;
	yarPad[i].data.Left         = (buttons & JOY_LEFT ) ? 0 : 1;
	yarPad[i].data.T            = (buttons & JOY_C_LEFT ) ? 0 : 1;
	yarPad[i].data.O            = (buttons & JOY_C_DOWN ) ? 0 : 1;
	yarPad[i].data.X            = (buttons & JOY_A      ) ? 0 : 1;
	yarPad[i].data.S            = (buttons & JOY_B      ) ? 0 : 1;
	yarPad[i].data.L2           = (buttons & JOY_C_UP   ) ? 0 : 1;
	yarPad[i].data.R2           = (buttons & JOY_C_RIGHT) ? 0 : 1;
	yarPad[i].data.Lx           = (_Controller[nuonIndex].properties & CTRLR_ANALOG1)
	  ? ((_Controller[nuonIndex].d1.xAxis > 0)
	     ? (((_Controller[nuonIndex].d1.xAxis * maxXMult[i]) >> 8) + 0x80)
	     : (((_Controller[nuonIndex].d1.xAxis * minXMult[i]) >> 8) + 0x80))
	  : 0x80;
	yarPad[i].data.Ly           = (_Controller[nuonIndex].properties & CTRLR_ANALOG1)
	  ? ((_Controller[nuonIndex].d2.yAxis > 0)
	     ? (-((_Controller[nuonIndex].d2.yAxis * maxYMult[i]) >> 8) + 0x80)
	     : (-((_Controller[nuonIndex].d2.yAxis * minYMult[i]) >> 8) + 0x80))
	  : 0x80;
	yarPad[i].data.Rx           = 0x80;
	yarPad[i].data.Ry           = 0x80;
	//	printf("pad=%08X ADDR=%08X\n", yarPad[i].raw.digital, &yarPad[i]);
	if ( i == 1) {
	  //	  printf("%08X %08X -- ", buttons, _Controller[nuonIndex].properties);
	}
      } else {
	yarPad[i].data.Ly = 0xFF;
      }
    } else {
      yarPad[i].data.Ly = 0xFF;
    }

    /*
    if ( i == 0) {
      if ( ((head + 1) != tail) && ((head != 1023) || (tail != 0))) {
	controllerBuffer[head]  = _Controller[nuonIndex].d2.yAxis;
	controllerBuffer2[head] = yarPad[i].data.Ly;
	controllerBuffer3[head] = (_Controller[nuonIndex].d2.yAxis > 0) ? maxYMult[i] : minYMult[i];
	head++;
	if ( head > 1023) head = 0;
      }
      }
    */
  }
}

// =================================================================================================
// Assumptions:
// - Rectangle given by parameters is entirely within one frame buffer
// - 24-bit images have an even width (i.e. data is a multiple of 16-bits)
//
//void copyYarozeToFB(RECT *rect, int fbIndex)
void copyYarozeToFB(RECT *rect, sFB *fb)
{
  int i;
  int offsetX, offsetY, offsetX24;
  int w, h, w24;
  char *ptrSrc, *ptrDest;
  //  int fbOffset = 0;
  unsigned long *ptrLong;
  int debug = 1;

  if ( dmaFlagsWr == 0 )
  {
    return;
  }

  for ( offsetY = 0; offsetY < rect->h; offsetY += h )
  {
    h = getOptimalH(rect, offsetY, 64, 0);

    for ( offsetX = offsetX24 = 0; offsetX < rect->w; offsetX += w, offsetX24 += w24 )
    {
      w = getOptimalW( rect, offsetX, 64, h, 2 );
     
      if ( bufferMode == BUFFER_MODE_16BIT) {
	_DMABiLinear(YAROZE_DMA_FLAGS_RD2, yarozeBuff,
		     (w<<16) | ((rect->x + offsetX)<<0),
		     (h<<16) | ((rect->y + offsetY)<<0),
		     localScratch);

	// Move STP bit
	ptrLong = (unsigned long *) localScratch;
	for ( i = w * h; i; i--, ptrLong++)
	{
	  if ( ptrLong[0] & 0x04000000 )
	  {
	    ptrLong[0] = (ptrLong[0] & ~0x04000000) | 0x1;
	  }
	  if ( ( ptrLong[0] & 0xFFFFFF00 ) == 0x10808000 )
	  {
	    ptrLong[0] ^= 0x1;  // STP bit is swapped for black pixels
	  }
	}

	_DMABiLinear( dmaFlagsWr, fb->ptr,
#ifdef USE_BORDERX
		      ( w << 16 ) | ( ( rect->x - fb->x + offsetX + borderX ) << 0 ),
#else
		      ( w << 16 ) | ( ( rect->x - fb->x + offsetX           ) << 0 ),
#endif
		      ( h << 16 ) | ( ( rect->y - fb->y + offsetY           ) << 0 ),
		      localScratch );
      }
      else
      {
	//	printf("24bit\n");
	_DMABiLinear( YAROZE_DMA_FLAGS_RD, yarozeBuff,
		      (w<<16) | ((rect->x + offsetX)<<0),
		      (h<<16) | ((rect->y + offsetY)<<0),
		      localScratch );

	// Convert width to 24-bit pixels
	w24 = (w<<1) / 3;
	ptrSrc  = localScratch + (w24 * h * 3) - 3;  // Point to last 24-bit data
	ptrDest = localScratch + (w24 * h * 4) + 8;  // Leave room so we do not overwrite ourself

	for (; ptrSrc >= localScratch; ptrSrc -= 3, ptrDest -= 4)
	  memcpy(ptrDest, ptrSrc, 3);

	//	fbOffset = (bufferW - 320) >> 1;

	_DMABiLinear(dmaFlagsWr, fb->ptr,
#ifdef USE_BORDERX
		     (w24<<16)|((rect->x - fb->x + offsetX24 + borderX)<<0),
#else
		     (w24<<16)|((rect->x - fb->x + offsetX24)<<0),
#endif
		     (h  <<16)|((rect->y - fb->y + offsetY            )<<0),
		     localScratch + 12);
	
      }
    }
  }
}

// =================================================================================================

void checkOverlap(int x, int y, int w, int h)
{
  int i;
  RECT newRect;
  int tpage;
  int imgX, imgY, imgW, imgH;
  sImage *img;
  sClut *clut;
  int clash;
  int debug = FUNC_TRACE;

  // Check if this ovewrote the frame buffer.  If so, regenerate those pixels.
  for (i = 0; i < MAX_FB; i++) {

    if ( aFB[i].ptr) {

      if ( ((x < (aFB[i].x + screenW16)) && ((x + w) > aFB[i].x)) &&
	  ((y < (aFB[i].y + screenH  )) && ((y + h) > aFB[i].y))) {

	if ( debug != 0 ) printf("YARLIB checkOverlap(%d, %d, %d, %d) overlapped fb %d (%08X)\n",
			  x, y, w, h, i, aFB[i].ptr);
	
	// Get top-left corner
	newRect.x = (x > aFB[i].x) ? x : aFB[i].x;
	newRect.y = (y > aFB[i].y) ? y : aFB[i].y;
	
	// Get bottom-right corner
	newRect.w = ((x + w) < (aFB[i].x + screenW16)) ? (x + w) : (aFB[i].x + screenW16);
	newRect.h = ((y + h) < (aFB[i].y + screenH  )) ? (y + h) : (aFB[i].y + screenH  );

	// Subtract off to get H & W
	newRect.w -= newRect.x;
	newRect.h -= newRect.y;
	
	//	copyYarozeToFB(&newRect, i);
	copyYarozeToFB(&newRect, &aFB[i]);
      }
    }
  }

  // Get the tpage this rectangle starts in
  tpage = (x >> 6) + ((y >> 8) << 4);
  
  // Check if this overwrote an image.
  for (img = aImage[tpage]; img; img = img->next) {
    if ( !(img->flags & kImgFlagDirty)) {
      imgX = (img->uvwh >> 24) & 0xFF;
      imgY = (img->uvwh >> 16) & 0xFF;
      imgW = ((img->uvwh >> 8) & 0xFF) + 1;
      imgH = ((img->uvwh >> 0) & 0xFF) + 1;
      switch ((img->cxcycw & 0xFF) == 1)
      {
	case 1:  imgX >>= 2;  imgW >>= 2;  break;
	case 2:  imgX >>= 1;  imgW >>= 1;  break;
      }
      imgX += x & 0xFFFFFFC0;
      imgY += y & 0xFFFFFF00;
      
      if ( (x < (imgX+imgW)) && ((x + w) > imgX) && (y < (imgY+imgH)) && ((y + h) > imgY)) {
	if ( yarlibMemDebug)
	  printf("Image clash: tpage=%2d  UVWH=%08X  CXCYCW=%08X  x,y=%3d,%3d  w,h=%3d,%3d\n",
		 tpage, img->uvwh, img->cxcycw, x, y, w, h);
	img->flags |= kImgFlagDirty;
      }
    }
  }

  // Check if this overwrote a clut.
  for (clut = aClut[tpage]; clut; clut = clut->next) {
    // Check overlap with CLUT data
    if ( clut->cxcycw & 0xFF) {
      imgX = (clut->cxcycw >> 20) & 0xFFF;
      imgY = (clut->cxcycw >>  8) & 0xFFF;
      switch (clut->cxcycw & 0xFF) {
        case 1:  imgW = 16;   break;
        case 2:  imgW = 256;  break;
      }
      imgH = 1;

      clash = TRUE;
      if ( x < imgX) {
	if ( (x + w) <= imgX) clash = FALSE;
      } else if ( x >= (imgX + imgW)) {
	clash = FALSE;
      }
      if ( y < imgY) {
	if ( (y + h) <= imgY) clash = FALSE;
      } else if ( y >= (imgY + imgH)) {
	clash = FALSE;
      }
      
      if ( clash) {
	if ( yarlibMemDebug)
	  printf("CLUT clash:  tpage=%2d                 CXCYCW=%08X  x,y=%3d,%3d  w,h=%3d,%3d\n",
		 tpage, clut->cxcycw, imgX, imgY, w, h);

	for (i = 0; i < NUM_TPAGES; i++) {
	  if ( clut->tpages & (1<<i)) {
	    for (img = aImage[i]; img; img = img->next) {
	      if ( (img->cxcycw == clut->cxcycw) && !(img->flags & kImgFlagDirty)) {
		if ( yarlibMemDebug) printf("  Image in tpage %d: uvwh=%08X\n", i, img->uvwh);
		img->flags |= kImgFlagDirty;
	      }
	    }
	  }
	}
      }
    }
  }
  
}

// =================================================================================================
// getOptimalH()
// Find out the optimal height to use for transfering this block.
// =================================================================================================
int getOptimalH(RECT *rect, int y, int maxPix, int scaleH)
{
  int h;
  int round;
  int minH = 1<<scaleH;

  // Get the maximum number of rows that can be transfered
  h = maxPix / rect->w;

  // Clamp to minimum number of rows (normally 1)
  if ( h < minH) h = minH;

  // Clamp to end of image
  if ( h > (rect->h - y)) h = rect->h - y;

  // Round down to a multiple of the minimum height
  round = h & ~(minH - 1);
  if ( round) h = round;

  return h;

/* 
  int end;
  int w, h;

  // First get width.  Max is rectangle width.
  w = rect->w;

  // Clamp if that puts us past the end of the line
  //  end = rect->x + *w;
  end = x + w;
  if ( end > rect->w) w = rect->w - x;

  // Clamp if that puts us past the end of the tpage
  //  end = ((rect->x + x) & 0x3F) + w - 1;
  end = rect->x + w - 1;
  if ( (end & ~0x3FL) != (rect->x & ~0x3FL)) w = ((rect->x & ~0x3FL) + 64) - rect->x;

  // Clamp to 32 longs at max
  if ( w > maxPix) w = maxPix;

  // Assume height of one to start with
  h = 1;

  // Ensure width indicates a multiple of 3 bytes if in 24-bit mode
  if ( bufferMode == BUFFER_MODE_24BIT)
    while ((w * 2) % 3) w -= 2;

  // If this is the start of a line, the width takes the full line, and the width is not
  // odd then check and see if we can use height to bring in more data.
  if ( (x == 0) && (w == rect->w) && !(w & 0x1)) {

    // Get theoretical maximum height based on maxPix
    h = (maxPix>>1) / (w>>1);

    // Clamp if that puts us past the bottom of the image
    if ( (y + h) > rect->h) h = rect->h - y;

    // Clamp if that puts us past the bottom of the tpage
    end = rect->y + h - 1;
    if ( (end & ~0xFFL) != (rect->y & ~0xFFL)) h = ((rect->y & ~0xFFL) + 256) - rect->y;
  }

  // Factor in our minimum height
  if ( minH > 1) {
    end = h - (h % minH);   // round down to the next lowest multiple of minH
    if ( end > 0) h = end;   // only use it if it's not zero
  }

  return h;
*/
}

// =================================================================================================
// getOptimalW()
// Find out the optimal width to use for transfering this block.
// =================================================================================================
int getOptimalW(RECT *rect, int x, int maxPix, int h, int bppShift)
{
  int w;
  int end;
  unsigned long mask = 0xFF >> bppShift;

  w = maxPix / h;
  
  // Clamp if that puts us past the end of the line
  if ( w > (rect->w - x)) {
    w = rect->w - x;
  }
  
  // Clamp if that puts us past the end of the tpage
  end = rect->x + w - 1;
  if ( (end & ~mask) != (rect->x & ~mask)) {
    w = ((rect->x & ~mask) + 64) - rect->x;
  }
  
  // Ensure width indicates a multiple of 3 bytes if in 24-bit mode
  if ( bufferMode == BUFFER_MODE_24BIT) {
    while ((w * 2) % 3) {
      w -= 2;
    }
  }
  
  return w;
}
     
// =================================================================================================

void rgb2ycrcb(unsigned char *in_r, unsigned char *in_g, unsigned char *in_b)
{
  unsigned char out_r;
  unsigned char out_g;
  unsigned char out_b;

  float r, g, b;
  float y, cr, cb;

  unsigned char out_y,  in_y;
  unsigned char out_cr, in_cr;
  unsigned char out_cb, in_cb;

  unsigned short in_16bit, out_16bit;

  /*
    if ( mode == BUFFER_MODE_24BIT) {
      in_r = ptr[0];
      in_g = ptr[1];
      in_b = ptr[2];
    } else {
      in_16bit = *((unsigned short *) ptr);
      in_r = (in_16bit >> 10) & 0x1F;
      in_g = (in_16bit >>  5) & 0x1F;
      in_b = (in_16bit >>  0) & 0x1F;
      in_16bit &= 0x8000; // Keep transparency bit
      }
    */

  r = (float) *in_r / 255.0;
  g = (float) *in_g / 255.0;
  b = (float) *in_b / 255.0;

  y  =  (0.299 * r) + (0.587 * g) + (0.114 * b);
  cr =  (0.500 * r) - (0.419 * g) - (0.081 * b);
  cb = -(0.169 * r) - (0.331 * g) + (0.500 * b);

  y  = 219.0 * y  + 16.0;
  cr = 224.0 * cr + 128.0;
  cb = 224.0 * cb + 128.0;

  *in_r = y  + 0.5;
  *in_g = cr + 0.5;
  *in_b = cb + 0.5;
    /*
    out_16bit = in_16bit |
      ((unsigned short) (out_y  & 0xFC) << 8) | 
      ((unsigned short) (out_cr & 0xF8) << 2) | 
      ((unsigned short) (out_cb & 0xF8) >> 3);
    */
}

// =================================================================================================

void ycrcb2rgb(unsigned char *in_y, unsigned char *in_cr, unsigned char *in_cb)
{
  unsigned char out_r;
  unsigned char out_g;
  unsigned char out_b;

  float r, g, b;
  float y, cr, cb;

  unsigned char out_y;
  unsigned char out_cr;
  unsigned char out_cb;

  unsigned short in_16bit, out_16bit;

  y  = ((float) *in_y  - 16.0f)  / 219.0f;
  cr = ((float) *in_cr - 128.0f) / 224.0f;
  cb = ((float) *in_cb - 128.0f) / 224.0f;

  r = y + 1.40200 * cr;
  g = y - 0.34414 * cb - 0.71414 * cr;
  b = y + 1.77200 * cb;

  if ( r > 1.0) r = 1.0;
  if ( r < 0.0) r = 0.0;
  if ( g > 1.0) g = 1.0;
  if ( g < 0.0) g = 0.0;
  if ( b > 1.0) b = 1.0;
  if ( b < 0.0) b = 0.0;
  
  r *= 255.0f;
  g *= 255.0f;
  b *= 255.0f;

  *in_y  = r + 0.5;
  *in_cr = g + 0.5;
  *in_cb = b + 0.5;
  /*
  *in_y  = *in_y  + (((r - *in_y ) >= 0.5) ? 1 : 0);
  *in_cr = *in_cr + (((g - *in_cr) >= 0.5) ? 1 : 0);
  *in_cb = *in_cb + (((b - *in_cb) >= 0.5) ? 1 : 0);
  */
}
  
// =================================================================================================

#define MAX_SCREENSHOT_W 640
#define MAX_SCREENSHOT_H 512

void *captureAddr = NULL;
int captureW, captureH;
int specialButton = FALSE;

void screenshotCheck(int w, int h, int dmaFlags)
{
  int offsetX = 0, offsetY = 0;
  int x, y, i;
  char *ptr;
  static int stillDown = 0;
  static int printed = 0;
  int size;
  int thisW;

  if ( devSystem && (_Controller[1].buttons & JOY_L) && (_Controller[1].buttons & JOY_R)) {
    if ( !printed) {
      size = MAX_SCREENSHOT_W * MAX_SCREENSHOT_H * 4;
      screenshotBuffer = (void *) malloc (size);
      if ( !screenshotBuffer) {
	printf("\nERROR: Could not allocate %d bytes for screenshot buffer", size);
      }
    }

    if ( !stillDown) {
      //      captureAddr = yarozeBuff;
      //      captureW = 40;
      //      captureH = 96;
      if ( captureAddr) {
        if ( captureAddr != yarozeBuff) {
          w = captureW;
          h = captureH;
          dmaFlags = DMA_PIXEL_READ | ((w/8)<<16) | (4<<4);// | (1<<11);
        } else {
          dmaFlags = YAROZE_DMA_FLAGS_RD;
          w = captureW;
          h = captureH;
          offsetX = 832;
          offsetY = 416;
          if ( !printed) {
            printf("\nYaroze buffer capture: X,Y=%d,%d  W,H=%d,%d", offsetX, offsetY, w, h);
	  }
        }
      }

      if ( w & 0x7) w = (w & ~0x7) + 8;
          
      switch ((dmaFlags >> 4) & 0xF) {
        case 2:  size = w * h * 2;  break;
        case 4:  size = w * h * 4;  break;
        default:  size = 0;  break;
      }

      if ( size) {
        if ( !printed) {
          printf("\nBuffer address=%08X  Size=%d (%d scalars)  W,H=%d,%d",
                 (int) screenshotBuffer, size, size>>2, w, h);
          fflush(stdout);
        }

	stillDown = 1;
	ptr = screenshotBuffer;
	for (y = 0; y < h; y++)
	  for (x = 0; x < w; x += 8) {
            if ( captureAddr) {
              _DMABiLinear(dmaFlags, captureAddr, (8<<16)|((x+offsetX)<<0),(1<<16)|((y+offsetY)<<0),
                           localScratch);
	    } else {
              _DMABiLinear(dmaFlags, aFB[aFBIndex[drawBuffer]].ptr,
#ifdef USE_BORDERX
			   (8<<16) | (x + borderX), (1<<16) | y,
#else
			   (8<<16) | x, (1<<16) | y,
#endif
                           localScratch);
	    }
	    _DMALinear((8<<16), ptr, localScratch);
	    ptr += 8*((dmaFlags >> 4) & 0xF);
	  }
      } else {
	printf("\nUnrecognized buffer type %d\n", (dmaFlags >> 4) & 0xF);
      }
    }
    
    printed = 1;
  } else {
    stillDown = 0;
  }
}

// =================================================================================================

int yarGetOTIndex(GsOT *ot)
{
  int i;
  int debug = 0;

  if ( debug != 0 ) printf("YARLIB yarGetOTIndex(ot=%08X)\n", ot);

  // Look for this OT in the list of registered OTs
  for (i = 0; i < MAX_OTS; i++) {
    if ( aOT[i] == ot) {
      break;
    }
  }

  // If found the OT then return the index
  if ( aOT[i] == ot) {
    if ( debug != 0 ) printf("YARLIB yarGetOTIndex(): Found OT %d\n", i);
    return i;
  }

  //
  // Didn't find the OT so need to allocate space for it.
  //

  // Find first free slot
  for (i = 0; i < MAX_OTS; i++) {
    if ( !aOT[i]) {
      break;
    }
  }

  if ( i >= MAX_OTS) {
    printf("\nYARLIB ERROR: Overflow OT array.  Increase maximum (current=%d)\n", MAX_OTS);
    while (1);  // hang here
  }
  
  // Save the new OT and return the index
  if ( debug != 0 ) printf("YARLIB yarGetOTIndex(): New OT %d\n", i);
  aOT[i] = ot;

  //  if ( debug != 0 ) printf("YARLIB yarGetOTIndex() ends\n");
  
  return i;
}

// =================================================================================================

SPRITE* getNUONSprite(GsSPRITE *sp, sImage *img, GsOT *ot, int pri, int fastSprite)
{
#define GETSPRITE_ALL
#include "getsprite.c"
  /*
  int rotateNUON;
  int sin, cos;
  int offsetX, offsetY;
  int diffX, diffY;
  int scaleX, scaleY;
  int scaleR, scaleG, scaleB;
  unsigned long addRGB = 0;
  int transFG, transBG;
  int srcX = 0, srcY = 0;
  int hint = 0;
  
  if ( numSprites == MAX_SPRITES) {
    printf("\nERROR: Out of NUON sprites (max=%d)", MAX_SPRITES);  fflush(stdout);
    return NULL;
    
  } else {

    scaleX = fastSprite ? ONE : sp->scalex;
    scaleY = fastSprite ? ONE : sp->scaley;

    // No point in doing anything if sprite is scaled down so much that it disappears
    if ( (scaleX == 0) || (scaleY == 0)) {
      return NULL;
    }

    if ( fastSprite) {
      rotateNUON = 0;
      
      // Subtract one from width and height so the shift rounds down
      // (W&H are 1-based, X&Y are 0-based)
      offsetX = (sp->w-1)>>1;
      offsetY = (sp->h-1)>>1;
      
    } else {
      // Special case some common rotation angles to avoid the divide
      switch (sp->rotate) {
	case 0:         rotateNUON = 0;       break;
	case ( 90<<12): rotateNUON = 0x4000;  break;
	case (180<<12): rotateNUON = 0x8000;  break;
	case (270<<12): rotateNUON = 0xC000;  break;
	default:        rotateNUON = (sp->rotate << 4) / 360;  break;
      }

      diffX = ((sp->w-1)>>1) - sp->mx;
      diffY = ((sp->h-1)>>1) - sp->my;
      if ( scaleX != ONE) diffX = (diffX * scaleX) >> 4;  // 8.0 * 4.12 = 12.12 >> 4 = 12.8
      else               diffX <<= 8;
      if ( scaleY != ONE) diffY = (diffY * scaleY) >> 4;
      else               diffY <<= 8;
      FixSinCos(rotateNUON, &sin, &cos);
      cos >>= 20;  // Convert from 2.30 to 2.10
      sin >>= 20;
      offsetX = diffX * cos - diffY * sin;  // 2.10 * 12.8 = 14.18
      offsetY = diffY * cos + diffX * sin;
      offsetX = (offsetX >> 18) + ((offsetX >> 17) & 0x1);  // Convert from fixed point to integer
      offsetY = (offsetY >> 18) + ((offsetY >> 17) & 0x1);  // Convert from fixed point to integer
    }

    if ( sp->attribute & (1<<6)) {
      scaleR = scaleG = scaleB = (1<<16);
    } else {
      scaleR = sp->r << 9;
      scaleG = sp->g << 9;
      scaleB = sp->b << 9;
    }

    if ( screenFade) {
      scaleR = (scaleR * (0x100 - screenFade)) >> 8;
      scaleG = (scaleG * (0x100 - screenFade)) >> 8;
      scaleB = (scaleB * (0x100 - screenFade)) >> 8;
    }

    // Set flag for no transparency if given the appropriate hint
    if ( sp->attribute & SP_HINT_NOSIMPLETRANS) {
      hint |= kSprHintNoTransp;
    }

    // Set flag to debug this sprite if given the appropriate hint
    if ( sp->attribute & SP_HINT_DEBUG) {
      hint |= kSprHintDebug;
    }

    if ( sp->attribute & SP_HINT_EXTRA_INFO) {
      transFG = sp->transFG;
      transBG = sp->transBG;
    } else {
      if ( sp->attribute & (1<<30)) {
	switch ((sp->attribute>>28) & 0x3) {
	  case 0:  transBG = 1<<15;  transFG =  1<<15;  break;  // 0.5 + 0.5
	  case 1:  transBG = 1<<16;  transFG =  1<<16;  break;  // 1.0 + 1.0
	  case 2:  transBG = 1<<16;  transFG = -1<<16;  break;  // 1.0 - 1.0
	  case 3:  transBG = 1<<16;  transFG =  1<<14;  break;  // 1.0 + 0.25
	}
      } else {
	transFG = 1<<16;
	transBG = 0;
      }
    }

    if ( screenFlash) {
      if ( transFG < 0) {
	transFG *= ((1<<8) - screenFlash) * transFG;
      } else {
	addRGB = (screenFlash << 24) | (screenFlash << 16) | (screenFlash << 8);
      }
    }

    img->trans = transFG;

    if ( libSpriteDebug) {
      hint |= kSprHintPrint;
    }
    if ( (sp->attribute & SP_HINT_USE_RGB) && !screenFade) {
      hint |= kSprHintBakeRGB;

      if ( (transFG == 1<<16) && (transBG == 0)) {
	img->flags |= kImgFlagBakeYCrCb;
	hint |= kSprHintBakeYCrCb;
      }
    }
    if ( img->flags & kImgFlagFeedback) {
      srcX = ((sp->tpage & 0x0F) << 6) + sp->u - aFB[img->uvwh].x + borderX;
      srcY = ((sp->tpage & 0x10) << 4) + sp->v - aFB[img->uvwh].y;
      //      printf("Feedback:  srcX=%d  srcY=%d  Addr=%08X\n", srcX, srcY, img->info->img);
    }
    
    aSprite[numSprites] = SPRCreateSprite(img->info, srcX, srcY, sp->w, sp->h);
    if ( !aSprite[numSprites]) {
      return NULL;
    }
    
    if ( SPRAddSpriteYaroze(aSprite[numSprites], sp->x + offsetX, sp->y + offsetY, rotateNUON,
			   scaleX<<4, scaleY<<4, transFG, transBG, scaleR, scaleG, scaleB,
			   addRGB, 0xFFFFFFFF - pri, hint, yarGetOTIndex(ot))) {
      // On error, deallocate the sprite
      SPRDeleteSprite(aSprite[numSprites]);
      return NULL;
    }

    numSprites++;
    return aSprite[numSprites-1];
    }
  */
}

// =================================================================================================
// Same as above, but no rotation, RGB brightness, or translucency is allowed.  Scaling is allowed.
// =================================================================================================

SPRITE* getNUONSpriteNoRotate(GsSPRITE *sp, sImage *img, GsOT *ot, int pri, int fastSprite)
{
#undef GETSPRITE_ALL
#undef GETSPRITE_ROTATE
#define GETSPRITE_SCALE
#undef GETSPRITE_TRANS
#undef GETSPRITE_RGB
#include "getsprite.c"
  /*  
  int diffX, diffY;
  int scaleX, scaleY;
  int hint = 0;
  
  if ( numSprites == MAX_SPRITES) {
    printf("\nERROR: Out of NUON sprites (max=%d)", MAX_SPRITES);  fflush(stdout);
    return NULL;
    
  } else {

    scaleX = fastSprite ? ONE : sp->scalex;
    scaleY = fastSprite ? ONE : sp->scaley;
    
    // No point in doing anything if sprite is scaled down so much that it disappears
    if ( (scaleX == 0) || (scaleY == 0)) {
      return NULL;
    }

    diffX = ((sp->w-1)>>1) - sp->mx;
    diffY = ((sp->h-1)>>1) - sp->my;
    if ( scaleX != ONE) diffX = (diffX * scaleX) >> 4;  // 8.0 * 4.12 = 12.12 >> 4 = 12.8
    else               diffX <<= 8;
    if ( scaleY != ONE) diffY = (diffY * scaleY) >> 4;
    else               diffY <<= 8;
      
    // Set flag for no transparency if given the appropriate hint
    if ( sp->attribute & SP_HINT_NOSIMPLETRANS) {
      hint |= kSprHintNoTransp;
    }

    // Set flag to debug this sprite if given the appropriate hint
    if ( sp->attribute & SP_HINT_DEBUG) {
      hint |= kSprHintDebug;
    }

    img->trans = 1<<16;

    if ( libSpriteDebug) {
      hint |= kSprHintPrint;
    }
    
    aSprite[numSprites] = SPRCreateSprite(img->info, 0, 0, sp->w, sp->h);
    if ( !aSprite[numSprites]) {
      return NULL;
    }
    
    if ( SPRAddSpriteYaroze(aSprite[numSprites], sp->x + diffX, sp->y + diffY, 0,
			   scaleX, scaleY, 1<<16, 0, 1<<16, 1<<16, 1<<16, // scale xy trans fgbg rgb
			   0, 0xFFFFFFFF - pri, hint, yarGetOTIndex(ot))) {
      // On error, deallocate the sprite
      SPRDeleteSprite(aSprite[numSprites]);
      return NULL;
    }

    numSprites++;
    return aSprite[numSprites-1];
  }
  */
}

// =================================================================================================
// Same as above, but no rotation, scaling, RGB brightness, or translucency is allowed.
// =================================================================================================

SPRITE* getNUONSpriteSimple(GsSPRITE *sp, sImage *img, GsOT *ot, int pri, int fastSprite)
{
#undef GETSPRITE_ALL
#undef GETSPRITE_ROTATE
#undef GETSPRITE_SCALE
#undef GETSPRITE_TRANS
#undef GETSPRITE_RGB
#include "getsprite.c"
  /*
  int hint = 0;
  
  if ( numSprites == MAX_SPRITES) {
    printf("\nERROR: Out of NUON sprites (max=%d)", MAX_SPRITES);  fflush(stdout);
    return NULL;
    
  } else {

    // No point in doing anything if sprite is scaled down so much that it disappears
    if ( (sp->scalex == 0) || (sp->scaley == 0)) {
      return NULL;
    }

    // Set flag for no transparency if given the appropriate hint
    if ( sp->attribute & SP_HINT_NOSIMPLETRANS) {
      hint |= kSprHintNoTransp;
    }

    // Set flag to debug this sprite if given the appropriate hint
    if ( sp->attribute & SP_HINT_DEBUG) {
      hint |= kSprHintDebug;
    }

    img->trans = 1<<16;

    if ( libSpriteDebug) {
      hint |= kSprHintPrint;
    }
    
    aSprite[numSprites] = SPRCreateSprite(img->info, 0, 0, sp->w, sp->h);
    if ( !aSprite[numSprites]) {
      return NULL;
    }
    
    if ( SPRAddSpriteYaroze(aSprite[numSprites], sp->x + ((sp->w-1)>>1), sp->y + ((sp->h-1)>>1), 0,
			   1<<16, 1<<16, 1<<16, 0, 1<<16, 1<<16, 1<<16, // scale x/y trans fg/bg rgb
			   0, 0xFFFFFFFF - pri, hint, yarGetOTIndex(ot))) {
      // On error, deallocate the sprite
      SPRDeleteSprite(aSprite[numSprites]);
      return NULL;
    }

    numSprites++;
    return aSprite[numSprites-1];
  }
  */
}

// =================================================================================================

SPRITE * getNUONLine(GsLINE *line, SPR_IMAGE_INFO *info, GsOT *ot, int pri)
{
  int lineLenX, lineLenY, lineLen;
  int rotateNUON;
  
  int offsetX, offsetY;
  int sin, cos;

  int scaleR, scaleG, scaleB;
  int transFG, transBG;
  int hint = 0;
  int addRGB = 0;
  
  if ( numSprites == MAX_SPRITES) {
    printf("\nERROR: Out of NUON sprites (max=%d)", MAX_SPRITES);  fflush(stdout);
    return(NULL);
    
  } else {
    lineLenX = abs(line->x0 - line->x1) + 1;
    lineLenY = abs(line->y0 - line->y1) + 1;
    lineLen = FixSqrt((lineLenX*lineLenX + lineLenY*lineLenY)<<8, 8);  // expensive, but oh well
    lineLen = (lineLen >> 8) + 1;//((lineLen & 0xFF) ? 1 : 0);

    offsetX = (line->x1 - line->x0) >> 1;  // sprite offset is half way between the end points
    offsetY = (line->y1 - line->y0) >> 1;
    
    if      (lineLenX == 1) rotateNUON = 0x4000;  // Vertical line
    else if ( lineLenY == 1) rotateNUON = 0x0000;  // Horizontal line
    else {
      // Diagonal line
      rotateNUON = (int) (0x10000 * (float) (atan2f(line->y1 - line->y0, line->x1 - line->x0) / (float) (2.0f * 3.1415926535f)));
    }

    scaleR = line->r << 8;  // Use << 8 instead of << 9 because range is 0x00-0xFF not 0x00-0x80
    scaleG = line->g << 8;
    scaleB = line->b << 8;

    if ( screenFade) {
      scaleR = (scaleR * (0x100 - screenFade)) >> 8;
      scaleG = (scaleG * (0x100 - screenFade)) >> 8;
      scaleB = (scaleB * (0x100 - screenFade)) >> 8;
    }

    if ( line->attribute & (1<<30)) {
      switch ((line->attribute>>28) & 0x3) {
	case 0:  transBG = 1<<15;  transFG =  1<<15;  break;  // 0.5 + 0.5
	case 1:  transBG = 1<<16;  transFG =  1<<16;  break;  // 1.0 + 1.0
	case 2:  transBG = 1<<16;  transFG = -1<<16;  break;  // 1.0 - 1.0
	case 3:  transBG = 1<<16;  transFG =  1<<14;  break;  // 1.0 + 0.25
      }
    } else {
      hint |= kSprHintNoTransp;
      transFG = 1<<16;
      transBG = 0;
    }

    if ( screenFlash) {
      if ( transFG < 0) {
	transFG *= ((1<<8) - screenFlash) * transFG;
      } else {
	addRGB = (screenFlash << 24) | (screenFlash << 16) | (screenFlash << 8);
      }
    }
    
    aSprite[numSprites] = SPRCreateSprite(info, 0, 0, lineLen, 1);
    if ( !aSprite[numSprites]) {
      return NULL;
    }
    
    aSprite[numSprites]->tint = 0;
    if ( SPRAddSpriteYaroze(aSprite[numSprites], line->x0 + offsetX, line->y0 + offsetY, rotateNUON,
			   1<<16, 1<<16, transFG, transBG, scaleR, scaleG, scaleB,
			   addRGB, 0xFFFFFFFF - pri, hint, yarGetOTIndex(ot))) {
      // On error, deallocate the sprite
      SPRDeleteSprite(aSprite[numSprites]);
      return NULL;
    }

    if ( !aSprite[numSprites]) return(NULL);

    numSprites++;
    return(aSprite[numSprites-1]);
  }
}

// =================================================================================================

SPRITE* getNUONBox(GsBOXF *box, SPR_IMAGE_INFO *info, GsOT *ot, int pri)
{
  int scaleX, scaleY;
  int scaleR, scaleG, scaleB;
  int transFG, transBG;
  int hint = 0;
  int addRGB = 0;
  int w, h;
  
  if ( numSprites == MAX_SPRITES)
  {
    printf( "\nERROR: Out of NUON sprites (max=%d)\n", MAX_SPRITES );
    return( NULL );
  }
  else
  {
    scaleR = box->r << 8;  // Use << 8 instead of << 9 because range is 0x00-0xFF not 0x00-0x80
    scaleG = box->g << 8;
    scaleB = box->b << 8;

    if ( box->w <= 128)
    {
      w = box->w;
      scaleX = 1<<16;
    }
    else
    {
      w = 128;
      scaleX = (box->w<<16) >> 7;  // const white image is 128 pixels wide
    }
    if ( box->h <= 128)
    {
      h = box->h;
      scaleY = 1<<16;
    }
    else
    {
      h = 128;
      scaleY = (box->h<<16) >> 7;  // const white image is 128 pixels high
    }
    if ( box->attribute & ( 1 << 30 ) )
    {
      switch ( ( box->attribute >> 28 ) & 0x3 )
      {
	case 0:  transBG = 1<<15;  transFG =  1<<15;  break;  // 0.5 + 0.5
	case 1:  transBG = 1<<16;  transFG =  1<<16;  break;  // 1.0 + 1.0
	case 2:  transBG = 1<<16;  transFG = -1<<16;  break;  // 1.0 - 1.0
	case 3:  transBG = 1<<16;  transFG =  1<<14;  break;  // 1.0 + 0.25
      }
    }
    else
    {
      hint |= kSprHintNoTransp;
      transFG = 1<<16;
      transBG = 0;
    }

    if ( screenFlash != 0 )
    {
      if ( transFG < 0 )
      {
	transFG *= ( ( 1 << 8 ) - screenFlash ) * transFG;
      }
      else
      {
	addRGB = ( screenFlash << 24 ) | ( screenFlash << 16 ) | ( screenFlash << 8 );
      }
    }
    
    aSprite[numSprites] = SPRCreateSprite( info, 0, 0, w, h );
    if ( aSprite[numSprites] == NULL )
    {
      return NULL;
    }
    
    aSprite[numSprites]->tint = 0;
    if ( SPRAddSpriteYaroze( aSprite[numSprites], box->x + ( box->w >> 1 ), box->y + ( box->h >> 1 ), 0,
			     scaleX, scaleY, transFG, transBG, scaleR, scaleG, scaleB,
			     addRGB, 0xFFFFFFFF - pri, hint, yarGetOTIndex( ot ) ) )
    {
      // On error, deallocate the sprite
      SPRDeleteSprite( aSprite[numSprites] );
      return NULL;
    }

    if ( aSprite[numSprites] == NULL )
    {
      return( NULL );
    }

    numSprites++;
    return( aSprite[numSprites-1] );
  }
}

// =================================================================================================

sImage * allocImage( GsSPRITE *sp )
{
  int i;
  int clutWidth;
  sImage *img;
  sClut *clut;
  int *ptr;
  unsigned long trans;
  unsigned long uvwh, cxcycw, rgbt, flags;
  SPR_IMAGE_INFO *info;
  int tpage;

  switch ( ( sp->attribute >> 24 ) & 0x3 )
  {
    case 0:  clutWidth = 1; break;
    case 1:  clutWidth = 2; break;
    case 2:  clutWidth = 0; break;
  }

  // Generate packed values for easier comparison
  uvwh = ( sp->u << 24 ) | ( sp->v << 16 );
  if ( sp->w != 0 )
  {
    uvwh |= (sp->w-1) << 8;
  }
  if ( sp->h )
  {
    uvwh |= sp->h-1;
  }
  cxcycw = ( sp->cx << 20 ) | ( sp->cy << 8 ) | clutWidth;
  rgbt = ( sp->r << 24 ) | ( sp->g << 16 ) | ( sp->b << 8 ) | 0xFF;

  flags = sp->attribute & SP_HINT_MASK;

  if ( sp->attribute & SP_HINT_GOT_IMAGE )
  {
    // If "info" is non-NULL then the image data exists
    img = (sImage*) sp->img;
    if ( img->info != NULL )
    {
      if ( ( ( sp->attribute & SP_HINT_BAKE_RGB ) == 0 ) || ( screenFade != 0 ) )
      {
	rgbt = img->rgbt & 0xFFFFFF00;
      }
      if ( ( uvwh == img->uvwh ) && ( cxcycw == img->cxcycw ) && ( rgbt == img->rgbt ) &&
	  ( ( flags & SP_HINT_PRESCALE_MASK ) == ( img->flags & SP_HINT_PRESCALE_MASK ) ) )
      {
	return img;
      }
    }
  }

  //  flags = sp->attribute & SP_HINT_MASK;

  // Special-case if the sprite image data comes from the frame buffer (feedback).  In that
  // case just snag the previous frame buffer's data directly.  No muss no fuss.
  if ( ( sp->attribute & SP_HINT_NO_FEEDBACK ) == 0 )
  {
    int x, y;
    x = ( ( sp->tpage & 0x0F ) << 6 ) + sp->u;
    y = ( ( sp->tpage & 0x10 ) << 4 ) + sp->v;

    i = drawBuffer;
    do {
      if ( aFB[i].ptr != NULL )
      {
#ifdef USE_BORDERX
	if ( ((x >= aFB[i].x) && (x < (aFB[i].x + screenW - (borderX<<1)))) &&
#else
	if ( ((x >= aFB[i].x) && (x < (aFB[i].x + aFB[i].w))) &&
#endif
	     ((y >= aFB[i].y) && (y < (aFB[i].y + aFB[i].h))) ) {
	  
	  if ( ((sp->attribute >> 24) & 0x3) != 2) {
	    printf("YARLIB ERROR: Feedback using sprite that isn't 16-bit\n");
	    printf("              XY=%d,%d  FB XYWH=%d,%d,%d,%d (index=%d)\n",
		   x, y, aFB[i].x, aFB[i].y, screenW, screenH, i);
	    return NULL;
	  }
	  /*
	  printf("Feedback: drawBuffer=%d (%08X)\n", drawBuffer, aFB[drawBuffer].ptr);
	  printf("Feedback: TPAGE=%d  U=%d  V=%d  Buffer=%d\n", sp->tpage, sp->u, sp->v, i);
	  printf("Checking for non-translucent pixels\n");
	  {
	    int x0, y0;
	    for (x0 = aFB[i].x; x0 < (aFB[i].x + aFB[i].w); x0++) {
	      for (y0 = aFB[i].y; y0 < (aFB[i].y + aFB[i].h); y0++) {
		_DMABiLinear(dmaFlagsRd, aFB[i].ptr, (1<<16) | x0, (1<<16) | y0, localScratch);
		if ( (((unsigned long *) localScratch)[0] & 0xFF) != 0x01) {
		  printf("%d,%d: %08X ", x0, y0, ((unsigned long *) localScratch)[0]);
		}
	      }
	    }
	  }
	  */
	  // Need to save the Yaroze frame buffer index in case NUON is quad buffered.
	  aFB[i].img.uvwh = i;
	  return &aFB[i].img;
	}
      }
      i--;
      if ( i < 0)
      {
	i = MAX_FB - 1;
      }
      if ( i == drawBuffer)
      {
	break;
      }
    } while (1);
  }
  
  if ( 0 && (flags & SP_HINT_USE_DIRECT)) {
#if 0
    // Check if we already have the image
    if ( flags & SP_HINT_GOT_DIRECT) {
      img = sp->img;
    } else {

      // Must search for the image in the array
      for (img = aImage[DIRECT]; img; img = img->next) {
	if ( img->info->img == sp->addr) {
	  sp->img = img;
	  break;
	}
      }
    }
#endif
  }
  else
  {
    // See if we already have this image available
    for (img = aImage[sp->tpage]; img; img = img->next)
    {
      if ( !(sp->attribute & SP_HINT_BAKE_RGB) || screenFade)
      {
	rgbt = img->rgbt & 0xFFFFFF00;
      }
      if ( (uvwh == img->uvwh) && (cxcycw == img->cxcycw) && (rgbt == img->rgbt) &&
	  ((flags & SP_HINT_PRESCALE_MASK) == (img->flags & SP_HINT_PRESCALE_MASK)))
      {
	break;
      }
    }
      
    if ( img && yarlibDebug && (sp->attribute & SP_HINT_DEBUG))
    {
      printf("Alloc:       tpage=%d  uvwh=%08X  rgbt=%08X  img=%08X\n",
	     sp->tpage, img->uvwh, img->rgbt, img->info->img);
    }
  }
  
  // If found the image, return it
  if ( img != NULL )
  {
    return img;
  }

  if ( freeImages != NULL )
  {
    img = freeImages;
    freeImages = freeImages->next;
  }
  else
  {
    img = (sImage *) malloc (sizeof(sImage));
  }

  // Check if we got the memory
  if ( img == NULL)
  {
    printf("\nERROR: Failed to malloc 'img'");  fflush(stdout);
    return NULL;
  }

  img->uvwh   = uvwh;
  img->cxcycw = cxcycw;
  img->rgbt   = ((sp->attribute & SP_HINT_BAKE_RGB) && !screenFade) ? rgbt : 0;

  img->flags = flags;
  img->flags |= kImgFlagDirty; // force the image to be generated the first time
  if ( screenFade != 0 )
  {
    img->flags &= ~SP_HINT_BAKE_RGB;
  }
  if ( ( sp->attribute & (1<<30) ) == 0 )
  {
    img->flags |= kImgFlagNoTranslucent;
  }

  info = (SPR_IMAGE_INFO *) malloc (sizeof(SPR_IMAGE_INFO));

  // Check if we got the memory
  if ( info == NULL )
  {
    printf( "\nERROR: Failed to malloc 'info'" );  fflush( stdout );
    free( img );
    return NULL;
  }

  img->info = info;
  
  // Check for the clut
  if ( clutWidth > 0 )
  {
    tpage = ( sp->cx >> 6 ) + ( ( sp->cy >> 8 ) << 4 );
    for ( clut = aClut[tpage]; clut; clut = clut->next )
    {
      if ( cxcycw == clut->cxcycw )
      {
	break;
      }
    }

    // Clut not found, allocate one
    if ( clut == NULL )
    {
      //    if ( (((cxcycw >> 20) & 0xFFF) == 144) && (((cxcycw >>  8) & 0xFFF) == 481) )
      //      printf("  Allocating clut\n", uvwh, cxcycw);
      clut = (sClut*) malloc (sizeof(sClut));
      clut->next   = aClut[tpage];
      clut->cxcycw = cxcycw;
      clut->tpages = 0;
      aClut[tpage] = clut;
    }
    
    clut->tpages |= 1<<sp->tpage;
  }

  // REMOVED: Make width/height twice the dimensions of the source to handle wrap around
  // Width must be a multiple of 8 for DMA purposes
  info->width = sp->w;//*2;
  if ( ( SPRITE_PRESCALE && !( img->flags & kImgFlagNoPrescale ) ) || ( img->flags & kImgFlagPrescale ) )
  {
    info->width = ( info->width >> dispScale ) + ( ( info->width & ( ( 1 << dispScale ) - 1 ) ) ? 1 : 0 );
  }
  info->width = ( info->width + 0x7 ) & ~0x7;
  
  // Height must be a multiple of 8
  info->height = sp->h;//*2;
  if ( ( SPRITE_PRESCALE && !( img->flags & kImgFlagNoPrescale ) ) || ( img->flags & kImgFlagPrescale ) )
  {
    info->height = ( info->height >> dispScale ) + ( ( info->height & ( ( 1 << dispScale ) - 1 ) ) ? 1 : 0 );
  }
  info->height = ( info->height + 0x7 ) & ~0x7;

  // Pixel mode is always 32-bit
  info->dmaflags = ( ( info->width >> 3 ) << 16 ) | ( 4 << 4 ) | DMA_PIXEL_READ;
  if ( info->width >= CLUSTER_WIDTH_LIMIT )
  {
    info->dmaflags |= 1 << 11;
  }

  allocImageData( sp, info );

  // Check if we got the memory
  if ( info->img == NULL )
  {
    printf("\nERROR: Failed to malloc 'info->img'");  fflush(stdout);
    free(info);
    free(img);
    return NULL;
  }

  if ( yarlibMemDebug != 0 )
  {
    printf("%7d: (+) tpage=%d  uvwh=%08X  rgbt=%08X  img=%08X\n",
	   totalImgAlloc, sp->tpage, img->uvwh, img->rgbt, img->info->img);
    fflush(stdout);
  }
  
  if ( ( yarlibDebug != 0 ) && ( ( sp->attribute & SP_HINT_DEBUG ) != 0 ) )
  {
    printf("Alloc:       tpage=%d  uvwh=%08X  rgbt=%08X  img=%08X\n",
	   sp->tpage, img->uvwh, img->rgbt, img->info->img);
  }
  
  // Add this image now that it's done
  img->next = aImage[sp->tpage];
  aImage[sp->tpage] = img;
  
  img->age = 0;

  return img;
}

// =================================================================================================

void* allocImageData(GsSPRITE *sp, SPR_IMAGE_INFO *info)
{
  // Try allocating the memory first
  info->img = _MemAlloc( info->width * info->height * 4, 512, kMemSDRAM );
  if ( info->img == NULL )
  {
    // Nope, didn't work.  Try deallocating other images that overlap this one.
    if ( sp != NULL )
    {
      freeImageMemory(kDeallocOverlap, sp);
      info->img = _MemAlloc( info->width * info->height * 4, 512, kMemSDRAM );
    }

    if ( info->img == NULL )
    {  
#if 0
      // Nope, didn't work.  Try deallocating other images in the same tpage.
      freeImageMemory(kDeallocTpage, sp);
      info->img = _MemAlloc(info->width * info->height * 4, 512, kMemSDRAM);
      if ( info->img ) return;
#endif
  
      // Nope, didn't work.  Deallocate everything that isn't bolted down.
      freeImageMemory( kDeallocAll, NULL );
      info->img = _MemAlloc( info->width * info->height * 4, 512, kMemSDRAM );
    }
  }

  if ( info->img != NULL )
  {
    totalImgAlloc += info->width * info->height * 4;

    if ( totalImgAlloc > maxTotalImgAlloc )
    {
      maxTotalImgAlloc = totalImgAlloc;
      //      printf( "maxTotalImgAlloc=%d\n", maxTotalImgAlloc );
    }
  }

  return info->img;
}

// =================================================================================================

void freeImageMemory(eDeallocMethod deallocMethod, GsSPRITE *sp)
{
  int tpage;
  sImage *img, *nextImg, *prevImg;
  int dealloc;
  int u, v, w, h;
  int debug = 0;

  if ( yarlibMemDebug || debug)
  {
    printf("Deallocating ");
    switch (deallocMethod)
    {
      case kDeallocOverlap:  printf("OVERLAP");  break;
      case kDeallocTpage:    printf("TPAGE");  break;
      case kDeallocOld:      printf("OLD");  break;
      case kDeallocAll:      printf("ALL");  break;
    }
    printf("\n");
  }
  
  for ( tpage = 0; tpage < 32; tpage++ )
  {
    img = aImage[tpage];
    nextImg = img ? img->next : NULL;
    prevImg = NULL;

    if ( ( deallocMethod == kDeallocOverlap ) || ( deallocMethod == kDeallocTpage ) )
    {
      if ( tpage != sp->tpage )
      {
	continue;
      }
    }
    
    while ( img != NULL )
    {
      if ( img->age > 1 )
      {
	// Don't deallocate if the user knows this is an often-used sprite
	dealloc = FALSE;

	if ( ( img->flags & ( kImgFlagPermImage | kImgFlagSticky ) ) == 0 )
	{
	  switch (deallocMethod) {
	    case kDeallocOverlap:
	      // Only got here if tpages matched (images won't overlap if tpages don't match)
	      // Now check for overlap.
	      u = ((img->uvwh >> 24) & 0xFF);
	      v = ((img->uvwh >> 16) & 0xFF);
	      w = ((img->uvwh >>  8) & 0xFF) + 1;
	      h = ((img->uvwh >>  0) & 0xFF) + 1; 
	      dealloc = ( ( sp->u < ( u + w ) ) && ( ( sp->u + sp->w ) > u ) &&
			  ( sp->v < ( v + h ) ) && ( ( sp->v + sp->h ) > v ) ) ? TRUE : FALSE;
	      break;
	    case kDeallocTpage:
	      // Only got here if tpages matched.
	      // Dealloc if the image isn't used this frame.
	      dealloc = TRUE;	    
	      break;
	    case kDeallocOld:
	      // Deallocate any images that haven't been used for a while
	      dealloc = ( img->age > IMG_DEALLOC_THRESH ) ? TRUE : FALSE;
	      break;
	    case kDeallocAll:
	      // Deallocate everything that isn't being used this frame
	      dealloc = TRUE;	    
	      break;
	  }
	}

	if ( dealloc != 0 )
	{
	  if ( prevImg != NULL )
	  {
	    prevImg->next = nextImg;
	  }
	  else
	  {
	    aImage[tpage] = nextImg;
	  }

	  if ( yarlibMemDebug != 0 )
	  {
	    printf("%7d: (-) tpage=%d  uvwh=%08X  rgbt=%08X  img=%08X  age=%d\n",
		   totalImgAlloc, tpage, img->uvwh, img->rgbt, img->info->img, img->age);
	    fflush(stdout);
	  }

	  totalImgAlloc -= img->info->width * img->info->height * 4;
	  _MemFree(img->info->img);
	  free(img->info);
	  img->info = NULL;
	  //	  free(img);
	  //	  img = NULL;
	  // Add this image to the list of free images.  We have to keep it around in case a
	  // GsSPRITE still references the structure.
	  img->next = freeImages;
	  freeImages = img;
	}
	else
	{
	  prevImg = img;
	}
	
      } else {
	prevImg = img;
      }

      img = nextImg;
      nextImg = img ? img->next : NULL;
    }
  }
  
  if ( yarlibMemDebug) {
    printf("Done.\n");
  }
}

// =================================================================================================

void generateImage(int tpage, sImage *img)
{
  int i;
  RECT rect;
  int w, h, x, y;
  int offsetX, offsetY;
  int subX, subY;
  unsigned long dmaFlags;
  unsigned long clut[256];
  unsigned long *pixelSrcLong, *pixelDst;
  unsigned long *pixelDstSaveY;
  unsigned short *pixelSrcShort;
  unsigned short pixel;
  unsigned long pixY, pixCR, pixCB, pixSTP;
  long r, g, b;
  unsigned char c1, c2, c3;
  int startOffset, endOffset;
  int pixW, curW, curH;
  int spriteX, spriteY;
  int tpageX, tpageY;
  int numPix;
  int dstX;
  int scalePix;
  long fillVal;
  int bppShift, bppPix, bppMask, bppClut;
  int thisSprite = FALSE;
  int clutsToRead, clutsRead;

  //  unsigned long *ptr;
  //  int debug = FALSE;

  if ( yarlibMemDebug != 0 )
  {
    printf("Regenerating image: tpage=%d uvwh=%08X", tpage, img->uvwh);
    if ( img->flags & kImgFlagBakeRGB) printf(" rgbt=%08X", img->rgbt);
    printf("\n");
  }

#if 0
  if ( tpage == 21 ) {
    thisSprite = TRUE;
    printf("Found thisSprite:  tpage=%d\n", tpage);
  }
#endif
  
  _DCacheSync();

  img->flags &= ~kImgFlagDirty;
  rect.x = (tpage & 0x0F) << 6;
  rect.y = ((tpage & 0x10) << 4) + ((img->uvwh >> 16) & 0xFF);
  rect.w = ((img->uvwh >> 8) & 0xFF) + 1;
  rect.h = ((img->uvwh >> 0) & 0xFF) + 1;

  //  img->w1 = rect.w;  // rendered width

  tpageX = (tpage & 0x0F) << 6;
  tpageY = (tpage & 0x10) << 4;
  
  if ( (img->cxcycw & 0xFF) == 1) {
    // 4-bit sprites
    bppShift = 2;
  } else if ( (img->cxcycw & 0xFF) == 2) {
    // 8-bit sprites
    bppShift = 1;
  }
  bppPix  = 1<<bppShift;
  bppMask = bppPix-1;
  bppClut = 1 << (16 >> bppShift);
  
  // When pixel does not start on 4-pixel boundary
  startOffset = (img->uvwh >> 24) & bppMask;

  // Compensate for the fact that there could be 2 or 4 pixels per 16-bit word
  rect.x += ((img->uvwh >> 24) & 0xFF) >> bppShift;

  rect.w += startOffset;                   // If sprite starts offset, need to bring in extra data
  if ( rect.w & bppMask) rect.w += bppPix;  // Round up if width is not multiple of 2 or 4
  endOffset = (bppPix - (rect.w & bppMask)) & bppMask;  // How many pixels at end should be ignored
  rect.w >>= bppShift;                     // Pixels per word

  for ( clutsRead = 0; clutsRead < bppClut; clutsRead += clutsToRead )
  {
    clutsToRead = bppClut - clutsRead;
    if ( clutsToRead > 64 )
    {
      clutsToRead = 64;
    }

    // Read the CLUT
    _DMABiLinear( YAROZE_DMA_FLAGS_RD, yarozeBuff,
		  ( clutsToRead << 16 ) | ( ( ( ( img->cxcycw >> 20 ) & 0xFFF ) + clutsRead ) << 0 ),
		  (           1 << 16 ) | ( (   ( img->cxcycw >>  8 ) & 0xFFF )               << 0 ),
		  localScratch);
  
    /*
      if ( yarlibDebug && (tpage == 31)) {
      printf("CLUT Read X,Y=%d,%d  W,H=%d,%d\n", (((img->cxcycw >> 20) & 0xFFF)<<0),
      (((img->cxcycw >> 8) & 0xFFF)<<0), bppClut, 1);
      }
    */

    /*
      printf("useRGB=%d  Alpha=%d  incRGB=%d\n",
      img->flags & kImgFlagBakeRGB, flagsSpriteLib & SPR_FLAG_USE_ALPHA,
      img->flags & kImgFlagBakeYCrCb);
    */
    
    // Convert 16bpp CLUT entries to 32bpp
    for ( i = 0; i < clutsToRead; i++ )
    {
      clut[i+clutsRead] = ((unsigned short *) localScratch)[i];
      pixY   = ((clut[i+clutsRead] >> 11) & 0x1F) << 3;
      pixCR  = ((clut[i+clutsRead] >>  5) & 0x1F) << 3;
      pixCB  = ((clut[i+clutsRead] >>  0) & 0x1F) << 3;
      pixSTP = ((clut[i+clutsRead] >> 10) & 0x01);
      if ( (clut[i+clutsRead] & 0xFBFF) == 0x1210) pixSTP = 1 - pixSTP;

      if ( img->flags & kImgFlagBakeRGB) {
	c1 = pixY;
	c2 = pixCR;
	c3 = pixCB;

	// Convert to RGB
	ycrcb2rgb(&c1, &c2, &c3);

	r = c1;
	g = c2;
	b = c3;
	
	// Apply RGB brightness
	// Don't apply translucency.  Pixels that are not translucent still need RGB applied.
	r = (r * ((img->rgbt >> 24) & 0xFF)) >> 7;  // R  (RGB brightness is in 1.7)
	g = (g * ((img->rgbt >> 16) & 0xFF)) >> 7;  // G
	b = (b * ((img->rgbt >>  8) & 0xFF)) >> 7;  // B

	// When not using alpha we can bake in the translucency as well
	if ( (img->trans > 0) && !(flagsSpriteLib & SPR_FLAG_USE_ALPHA)) {
	  r = (r * img->trans) >> 16;
	  g = (g * img->trans) >> 16;
	  b = (b * img->trans) >> 16;
	}

	if ( r > 0xFF) r = 0xFF;
	if ( g > 0xFF) g = 0xFF;
	if ( b > 0xFF) b = 0xFF;

	// Check if we're supposed to convert back to YCrCb afterwards
	if ( img->flags & kImgFlagBakeYCrCb) {
	  c1 = (unsigned char) r;
	  c2 = (unsigned char) g;
	  c3 = (unsigned char) b;
	  rgb2ycrcb(&c1, &c2, &c3);
	  r = c1;
	  g = c2;
	  b = c3;
	}

	clut[i+clutsRead] = (r<<24) | (g<<16) | (b<<8) | (pixSTP<<0);

	// Need to keep transparent pixels as 0x10808001 because the sprite library puts a border
	// around the sprite image data and uses that value.  So a transparent black RGB value of
	// 0x00000001 needs to change to 0x10808001 and an RGB value that happens to be 0x10808001
	// needs to change to something else.
	if ( ( img->flags & kImgFlagBakeYCrCb ) == 0 )
	{
	  if ( clut[i+clutsRead] == 0x10808001 )
	  {
	    clut[i+clutsRead] = 0x11808001;
	  }
	  if ( clut[i+clutsRead] == 0x00000001 )
	  {
	    clut[i+clutsRead] = 0x10808001;
	  }
	}
      }
      else
      {
	clut[i+clutsRead] = (pixY<<24) | (pixCR<<16) | (pixCB<<8) | (pixSTP<<0);
      }
    }
  }
    
  // When combining pixels, need room to accumulate.
  // Shift clut values down 3 bits - those are zero anyway.
  if ( ( img->flags & kImgFlagScaleMethod ) == kImgFlagScaleFilter )
  {
    for ( i = 0; i < bppClut; i++ )
    {
      clut[i] = (clut[i] >> 3) | (clut[i] & 0x1) | 0x10;  // preserve stp bit
    }
  }

  // Cycle through the pixels
  for ( offsetY = 0, spriteY = 0; offsetY < rect.h; offsetY += h, spriteY += curH )
  {
    h = getOptimalH( &rect, offsetY, 32, dispScale );

    if ( 0 && thisSprite )
    {
      printf("offsetY=%d  h=%d  rect.y=%d\n", offsetY, h, rect.y);
    }
	
    // subY handles wrapping around the bottom of the tpage
    if ( ( rect.y + offsetY ) >= 256 )
    {
      subY = 256;
    }
    else
    {
      subY = 0;
      // Clamp the height if it goes beyond the bottom of the tpage.
      if ( ( rect.y + offsetY + h ) > 256 )
      {
	h = 256 - rect.y - offsetY;
      }
    }
	  
    for ( offsetX = 0, spriteX = 0; offsetX < rect.w; offsetX += w, spriteX += curW )
    {
      w = getOptimalW(&rect, offsetX, 32, h, 2);

      pixW = w * bppPix;
      if ( offsetX == 0 ) pixW -= startOffset;
      if ( (offsetX + w ) >= rect.w ) pixW -= endOffset;

      // Read in the pixels at the end of the scratch buffer
      pixelSrcLong  = (unsigned long  *) (((long) localScratch + 384 - (w * h * 2)) & ~0x3);
      pixelSrcShort = (unsigned short *) pixelSrcLong;
	
      _DMABiLinear( YAROZE_DMA_FLAGS_RD, yarozeBuff,
		    ( w << 16 ) | (tpageX + ((rect.x - tpageX + offsetX       ) & (0xFF>>bppShift))),
		    ( h << 16 ) | (tpageY + ((rect.y          + offsetY - subY) &  0xFF           )),
		    pixelSrcLong);

      // To offset this from the base of local scratch memory you must reduce the "maxPix"
      // that is passed in to getOptimalH/W above.
      pixelDst = (unsigned long *) (localScratch);

      if ( (dispScale == 0) ||
	  (((SPRITE_PRESCALE == 0) || (img->flags & kImgFlagNoPrescale)) &&
	   !(img->flags & kImgFlagPrescale))) {

	for (y = 0; y < h; y++) {
	  if ( 0 && thisSprite && (offsetY == 2)) {
	    printf("%2d: ", spriteY+y);
	  }
	  
	  for (x = 0, curW = pixW; x < w; x++) {
	    pixel = *pixelSrcShort;

	    i = 0;
	    if ( (offsetX == 0) && (x == 0)) {
	      i = startOffset;
	      pixel >>= (startOffset << (4 - bppShift));  // shift by 2 for 4-bit, 3 for 8-bit
	    }

	    for (; (i < bppPix) && curW; i++, pixel >>= (16>>bppShift), pixelDst++, curW--) {

	      if ( 0 && thisSprite && (offsetY == 2)) {
		if ( bppShift == 2) {
		  printf("%X", pixel & (bppClut-1));
		} else {
		  printf("%02X", pixel & (bppClut-1));
		}
		printf("/%08X-", clut[pixel & (bppClut-1)]);
	      }

	      *pixelDst = clut[pixel & (bppClut-1)];
	    }
	    pixelSrcShort++;
	  }

	  if ( 0 && thisSprite && (offsetY == 2)) {
	    printf("\n");
	  }

	}

	curW = pixW;
	curH = h;
      }
      else
      {
	scalePix = 1<<dispScale;
	  
	if ( (img->flags & kImgFlagScaleMethod) != kImgFlagScaleSimple)
	{
	  switch (img->flags & kImgFlagScaleMethod)
	  {
	    case kImgFlagScaleNoBlack:  fillVal = 0x10808000;  break;
	    case kImgFlagScaleFilter:   fillVal = 0;  break;
	  }
	  pixelDst = (unsigned long *) (localScratch);
	  for (y = 0; y < h; y += scalePix)
	  {
	    for (curW = pixW; curW >= 0; curW -= scalePix, pixelDst++)
	    {
	      *pixelDst = fillVal;
	    }
	  }
	}
	    
	pixelDst = (unsigned long *) (localScratch);
	for (y = 0; y < h; )  // increment handled at end of loop
	{
	  pixelDstSaveY = pixelDst;
	    
//	  if ( y == 0) printf("%2d,%2d: ", offsetX, offsetY);
//	  else        printf("       ");
	  for (x = 0, dstX = 0, curW = pixW; x < w; x++)
	  {
	    pixel = *pixelSrcShort;

	    i = 0;
	    if ( (offsetX == 0) && (x == 0))
	    {
	      i = startOffset;
	      pixel >>= (startOffset << (4 - bppShift));  // shift by 2 for 4-bit, 3 for 8-bit
	    }
            
	    for (; (i < bppPix) && curW; i++, pixel >>= (16>>bppShift), curW--)
	    {
	      switch (img->flags & kImgFlagScaleMethod) {
		case kImgFlagScaleSimple:
		  *pixelDst = clut[pixel & (bppClut-1)];
		  break;
		case kImgFlagScaleNoBlack:
		  if ( (clut[pixel & (bppClut-1)] & 0xFFFFFF00) != 0x10808000)
		  {
		    *pixelDst = clut[pixel & (bppClut-1)];
		  }
		  break;
		case kImgFlagScaleFilter:
		  *pixelDst += clut[pixel & (bppClut-1)];
		  break;
	      }
	      //	      if ( pixel & 0xF) printf("%X", pixel & 0xF);
	      //	      else             printf("-");
		
	      //	      if ( debug != 0 ) {
	      //		printf("y,x,i=%d,%d,%d  pixelDst=%08X\n", y, x, i, pixelDst);
	      //	      }
	    
	      dstX++;
	      if ( !(dstX & (scalePix - 1))) pixelDst++;
	    }
	    pixelSrcShort++;
	  }
//	  printf("\n");

	  if ( dstX & (scalePix - 1)) pixelDst++;
	  y++;
	  if ( y & (scalePix - 1)) pixelDst = pixelDstSaveY;
	}
	  
#if ( 0)
	pixelDst = (unsigned long *) (localScratch);
	for (y = 0; y < (h>>1); y++) {  // increment handled at end of loop
	  printf("       ");
	  for (x = 0; x < (pixW>>1); x++) {
	    if ( ((*pixelDst >> 24) & 0xFF) == 0x10) printf("--");
	    else                                    printf("%02X", (*pixelDst >> 24) & 0xFF);
	    pixelDst++;
	  }
	  printf("\n");
	}
#endif
	  
	// Figure out how many pixels in final block
	curW = ( pixW >> dispScale ) + ( ( pixW & ( scalePix - 1 ) ) ? 1 : 0 );
	curH = ( h    >> dispScale ) + ( ( h    & ( scalePix - 1 ) ) ? 1 : 0 );
	  
	if ( ( img->flags & kImgFlagScaleMethod ) == kImgFlagScaleFilter )
	{
	  // Divide by the number of pixels we combined
	  pixelDst = (unsigned long *) localScratch;
	  for ( y = 0; y < curH; y++ )
	  {
	    for ( x = 0; x < curW; x++, *pixelDst++ )
	    {
	      numPix = (*pixelDst >> 4) & 0xF;
	      pixY  = ( ( ( ( *pixelDst <<  0) & 0xFF000000 ) / numPix ) >> 24 ) & 0xFF;
	      pixCR = ( ( ( ( *pixelDst <<  8) & 0xFF000000 ) / numPix ) >> 24 ) & 0xFF;
	      pixCB = ( ( ( ( *pixelDst << 16) & 0xFF000000 ) / numPix ) >> 24 ) & 0xFF;
	      if ( img->flags & kImgFlagNoTranslucent )
	      {
		pixSTP = ((*pixelDst & 0xF) == ((*pixelDst>>4) & 0xF)) ? 1 : 0;
	      }
	      else
	      {
		pixSTP = (*pixelDst & 0xF) ? 1 : 0;
	      }
	      *pixelDst = (pixY<<27) | (pixCR<<19) | (pixCB<<11) | (pixSTP<<0);
	    }
	  }
	}
      }

      dmaFlags = DMA_PIXEL_WRITE | ( ( img->info->width >> 3 ) << 16 ) | ( 4 << 4 );// | (1<<11);
      if ( img->info->width >= CLUSTER_WIDTH_LIMIT )
      {
	dmaFlags |= 1 << 11;
      }

#if ( 0 )
      if ( yarlibDebug) {
	printf("To:   x,y=%d,%d  w,h=%d,%d\n", spriteX, spriteY, curW, curH);
      }
#endif

#if ( 1)
      if ( 0 && thisSprite)
      {
	pixelDst = (unsigned long *) (localScratch);
	for ( y = 0; y < curH; y++ )
	{
	  printf("%08X %d: ", img->info->img, spriteY+y);
	  for ( x = 0; x < curW; x++, *pixelDst++ )
	  {
	    printf("%08X ", *pixelDst);
	  }
	  printf("\n");
	}
      }
#endif

      _DMABiLinear( dmaFlags, img->info->img,
		    ( curW << 16 ) | ( spriteX << 0 ),
		    ( curH << 16 ) | ( spriteY << 0 ),
		    localScratch);
    }
  }

  if ( thisSprite )
  {
    yarCRCBilinear((void*) 0x403AF400, 0, 0, 4, 4, 256, TRUE, __func__);
  }
}

// =================================================================================================

sImage* yarSpriteToImage( GsSPRITE *sp )
{
  sImage *img;
  int debug = 0;

  if ( debug )
  {
    printf( "%s(): Converting GsSPRITE to Image\n", __func__ );
  }

  sp->attribute |= SP_HINT_PERM_IMAGE;
  img = allocImage( sp );
  img->trans = 0;
  generateImage( sp->tpage, img );

  return( img );
}

// =================================================================================================

sImage* yarSpriteToImageGrid( GsSPRITE spArray[], int numRows, int numCols )
{
  GsSPRITE *spr;
  sImage *img, *imgAll;
  int row, col;
  int w, h;
  int wAll = 0, hAll = 0;
  int x, y;
  int xAll, yAll;
  int debug = 0;

  if ( debug != 0 )
  {
    printf( "%s(): Converting GsSPRITEs to Image (grid)\n", __func__ );
  }
 
  // First do some sanity checks
  if ( numRows < 1 )
  {
    printf( "%s(): numRows must be 1 or more\n", __func__ );
    return NULL;
  }
  if ( numCols < 1 )
  {
    printf( "%s(): numCols must be 1 or more\n", __func__ );
    return NULL;
  }
  // All images in the same row must have the same height
  for ( row = 0, spr = spArray; row < numRows; row++ )
  {
    h = -1;
    for ( col = 0; col < numCols; col++, spr++ )
    {
      if ( h == -1 )
      {
	h = spr->h;
      }
      else if ( h != spr->h )
      {
	printf( "%s: Row %d sprites are not all the same height (%d vs %d)\n", __func__, row, h, spr->h );
	return NULL;
      }
    }
    if ( debug != 0 )
    {
      printf( "%s(): Row %d height = %d\n", __func__, row, h );
    }
    hAll += h;
  }
  // All images in the same column must have the same width
  for ( col = 0, spr = spArray; col < numCols; col++, spr = &spArray[col] )
  {
    w = -1;
    for ( row = 0; row < numRows; row++, spr += numCols )
    {
      if ( w == -1 )
      {
	w = spr->w;
      }
      else if ( w != spr->w )
      {
	printf( "%s: Column %d sprites are not all the same width (%d vs %d)\n", __func__, col, w, spr->w );
	return NULL;
      }
    }
    wAll += w;
    if ( debug != 0 )
    {
      printf( "%s(): Column %d width = %d\n", __func__, col, w );
    }
  }

  //
  // Create the master image
  //

  if ( debug != 0 )
  {
    printf( "%s(): Allocating master image\n", __func__ );
  }
  imgAll = (sImage *) malloc ( sizeof(sImage) );

  // Check if we got the memory
  if ( imgAll == NULL )
  {
    printf("\nERROR: Failed to malloc 'imgAll'\n");
    return NULL;
  }

  if ( debug != 0 )
  {
    printf( "%s(): Allocating master image info\n", __func__ );
  }
  imgAll->flags = kImgFlagPermImage;
  imgAll->info = (SPR_IMAGE_INFO *) malloc ( sizeof(SPR_IMAGE_INFO) );

  // Check if we got the memory
  if ( imgAll->info == NULL )
  {
    printf( "\nERROR: Failed to malloc 'imgAll->info'\n" );
    free( imgAll );
    return NULL;
  }

  // Pixel mode is always 32-bit
  imgAll->info->width  = wAll;
  imgAll->info->height = hAll;
  imgAll->info->dmaflags = ( ( imgAll->info->width >> 3 ) << 16 ) | ( 4 << 4 ) | DMA_PIXEL_READ;
  if ( imgAll->info->width >= CLUSTER_WIDTH_LIMIT )
  {
    imgAll->info->dmaflags |= 1 << 11;
  }

  if ( debug != 0 )
  {
    printf( "%s(): Allocating master image data: w=%d, h=%d\n", __func__, imgAll->info->width, imgAll->info->height );
  }
  if ( allocImageData( NULL, imgAll->info ) == NULL )
  {
    printf( "\nERROR: Failed to malloc 'imgAll->info->img'\n" );
    free( imgAll->info );
    free( imgAll );
    return NULL;
  }

  //
  // Fill the master image with the sub images
  //

  for ( row = 0, yAll = 0, spr = spArray; row < numRows; row++ )
  {
    for ( col = 0, xAll = 0; col < numCols; col++, spr++ )
    {
      if ( debug != 0 )
      {
	printf( "%s(): Generating image in row %d, col %d\n", __func__, row, col );
      }
      // Allocate and generate the individual image
      img = allocImage( spr );
      img->trans = 0;
      generateImage( spr->tpage, img );

      // Copy the individual image to the overall image
      if ( debug != 0 )
      {
	printf( "%s(): Copying to master image starting at %d,%d\n", __func__, xAll, yAll );
      }
      for ( y = 0; y < img->info->height; y++ )
      {
	for ( x = 0; x < img->info->width; x += 16 )
	{
	  w = 16;
	  if ( ( x + w ) > img->info->width )
	  {
	    w = img->info->width - x;
	  }
	  _DMABiLinear( img->info->dmaflags,
			img->info->img,
			( w << 16 ) | ( x << 0 ),
			( 1 << 16 ) | ( y << 0 ),
			localScratch );
	  _DMABiLinear( ( ( imgAll->info->width >> 3 ) << 16 ) | ( 4 << 4 ) | DMA_PIXEL_WRITE,
			imgAll->info->img,
			( w << 16 ) | ( ( xAll + x ) << 0 ),
			( 1 << 16 ) | ( ( yAll + y ) << 0 ),
			localScratch );
	}
      }

      xAll += spr->w;
    }
    spr--;
    yAll += spr->h;
    spr++;
  }

  return( imgAll );
}

// =================================================================================================

void yarDeallocImage(sImage *img)
{
  totalImgAlloc -= img->info->width * img->info->height * 4;
  _MemFree(img->info->img);
  free(img->info);
  img->info = NULL;
}

// =================================================================================================

void crcLinear(void *addr, int numBytes, char *str, int print)
{
  int i, crc = 0;
  unsigned short *ptr = (unsigned short *) addr;
  
  if ( print) printf("\n");
  for (i = 0; i < (numBytes/2); i++, ptr++) {
    if ( print)
      printf("%04X%s", *ptr, (!((i+1)&0xF)) ? "\n" : " ");
    crc += ((*ptr >> 8) & 0x00FF) | ((*ptr << 8) & 0xFF00);
  }
  printf("\n%s CRC=%08X", str, crc);
  fflush(stdout);
}

// =================================================================================================

void yarCRCBilinear(void *addr, int x, int y, int w, int h, int buffW_in, int print, char *string)
{
  int offsetX, offsetY;
  int thisW;
  int i;
  unsigned char *ptr;
  int crc = 0;
  int buffW = YAROZE_VRAM_WIDTH;
  int dmaFlags;
  int numBytesMult;

  _DCacheFlush();

  if ( (addr == yarozeBuff) || (addr == 0)) {
    addr = yarozeBuff;
    numBytesMult = 2;
    dmaFlags = (DMA_PIXEL_READ  | ((buffW/8)<<16) | (1<<11) | (2<<4));
  } else {
    numBytesMult = 4;
    buffW = buffW_in;
    dmaFlags = (DMA_PIXEL_READ  | ((buffW/8)<<16) | (4<<4));
  }
  
  //  printf("\ndmaFlags=%08X", dmaFlags);

  if ( print) printf("\n");
  for (offsetY = 0; offsetY < h; offsetY++)
  {
    for (offsetX = 0; offsetX < w; offsetX += thisW)
    {
      thisW = w - offsetX;
      if ( thisW > 32) thisW = 32;

      //      printf(" X,W=%d,%d  Y,H=%d,%d", x+offsetX, thisW, y+offsetY, 1);
      _DMABiLinear(dmaFlags, addr,
		   (thisW<<16)|((x+offsetX)<<0),
		   (    1<<16)|((y+offsetY)<<0),
		   localScratch);

      ptr = (unsigned char *) localScratch;
      for (i = 0; i < (thisW * numBytesMult); i++, ptr++) {

        if ( print) {
          printf("%02X%c", *ptr, (!((i+1)&0xF)) ? '\n' : ' ');
	}

        crc += *ptr;
      }
    }
  }

  printf("%s%sCRC=%08X  ADDR=%08X  X,Y=%d,%d  W,H=%d,%d",//  Flags=%08X",
         string ? string : "", string ? " " : "", crc, addr, x, y, w, h);//, dmaFlags);
  printf("\n");
}

// =================================================================================================

void YarFillBuffer(int x, int y, int w, int h, int color)
{
  int i;
  int thisX, thisW;
  int debug = FUNC_TRACE;
  
  // Check if this ovewrote the frame buffer.  If so, regenerate those pixels.
  for (i = 0; i < MAX_FB; i++) {

    if ( aFB[i].ptr) {

      if ( ((x < (aFB[i].x + aFB[i].w)) && ((x + w) > aFB[i].x)) &&
	  ((y < (aFB[i].y + aFB[i].h)) && ((y + h) > aFB[i].y))) {

	if ( debug != 0 ) printf("YARLIB %s(%d, %d, %d, %d) overlapped fb %d (%08X)\n", __func__,
			  x, y, w, h, i, aFB[i].ptr);

	thisX = x;
	thisW = w;
	// If the region covers the whole buffer then extend it to hit the border area too.
	// Otherwise center it in the buffer.
	if ( (x == aFB[i].x) && (w == aFB[i].w)) {
	  thisW += borderX << 1;
	} else {
	  thisX += borderX;
	}
	
	YarFillRect(thisX - aFB[i].x, y - aFB[i].y, thisW, h, color, i);
      }
    }
  }

}

// =================================================================================================

void YarFillRect(int initx, int inity, int wide, int high, int color, int bufIndex)
{
  int x, y, w, h;
  int lastx, lasty;
  int debug = 0;

  if ( !dmaFlagsWr) return;
  if ( !aFB[bufIndex].ptr) return;

  if ( debug != 0 ) {
    printf("YARLIB YarFillRect(x,y=%d,%d w,h=%d,%d col=%08X, buf=%d (%08X))\n",
	   initx, inity, wide, high, color, bufIndex, aFB[bufIndex].ptr);
  }
 
  lastx = initx + wide;
  lasty = inity + high;

  for (x = initx; x < lastx; x += w)
  {
    w = ( ( x + 8 ) > lastx ) ? ( lastx - x ) : 8;
    for ( y = inity; y < lasty; y += h )
    {
      h = ( ( y + 8 ) > lasty ) ? ( lasty - y ) : 8;
      _DMABiLinear( dmaFlagsWr | DMA_DIRECT_BIT, aFB[bufIndex].ptr,
		    ( w << 16 ) | x, ( h <<16 ) | y, (void*) color );
    }
  }

  //  _Dma_wait((volatile int*) 0x20500600);
}

// =================================================================================================

void yarDefineSideBuffer(int x, int y, int w, int h, int pixType)
{
  RECT rect;
  int debug = 0;

  w += borderX*2;

  // Get the memory (freeing first if the dimensions changed)
  if ( sideBuffer.ptr && ((w != sideBufferW) || (h != sideBufferH))) {
    _MemFree(sideBuffer.ptr);
    sideBuffer.ptr = NULL;
  }

  if ( !sideBuffer.ptr) {
    sideBuffer.ptr = _MemAlloc(w * h * pixType, 512, kMemSDRAM);
    if ( !sideBuffer.ptr) {
      printf("\nERROR! Could not allocate %d bytes for side buffer\n", w*h*pixType);
      return;
    }

    if ( debug != 0 ) printf("Side buffer defined: Addr=%08X  W,H=%d,%d (borderX=%d)\n", sideBuffer.ptr, w, h, borderX);

    sideBufferW = w;
    sideBufferH = h;

    if ( (x != -1) && (y != -1)) {
      rect.x = x;
      rect.y = y;
      rect.w = w;
      rect.h = h;
      copyYarozeToFB(&rect, &sideBuffer);
    } else {
      int x0, y0;

      for (x0 = 0; x0 < w; x0 += 8)
      {
	for (y0 = 0; y0 < h; y0 += 8)
	{
	  _DMABiLinear(DMA_PIXEL_WRITE | ((sideBufferW/8)<<16) | (4<<4) | (1<<11) | DMA_DIRECT_BIT,
		       sideBuffer.ptr, (8<<16) | x0, (8<<16) | y0, (void*) YCrCb32_BLACK);
	}
      }

    }
  }
  
  sideBuffer.x = x;
  sideBuffer.y = y;
}

// =================================================================================================

void yarRenderToSideBuffer()
{
  sideRender = TRUE;
}

// =================================================================================================

void* yarGetSideBufferPtr()
{
  return sideBuffer.ptr;
}

// =================================================================================================

int yarGetSideBufferW()
{
  return sideBufferW;
}

// =================================================================================================

int yarGetSideBufferH()
{
  return sideBufferH;
}

// =================================================================================================

void yarSetSideBufferChannel()
{
  int i;

  // If no side buffer is defined then do nothing
  if ( sideBuffer.ptr == NULL )
  {
    return;
  }

  otherChannel = (yarChannel == VID_CHANNEL_MAIN) ? VID_CHANNEL_OSD : VID_CHANNEL_MAIN;

  vcOther.dmaflags    = DMA_PIXEL_READ  | ((sideBufferW/8)<<16) | (4<<4) | (1<<11);
  vcOther.base        = sideBuffer.ptr;
  vcOther.dest_xoff   = -1;
  vcOther.dest_yoff   = -1;
  vcOther.dest_width  = vd.dispwidth;
  vcOther.dest_height = vd.dispheight;
  //  vcOther.dest_width  = 720;
  //  vcOther.dest_height = 480;
  vcOther.src_xoff    = 0;
  vcOther.src_yoff    = 0;
  vcOther.src_width   = sideBufferW;
  vcOther.src_height  = sideBufferH;
  vcOther.clut_select = 0;
  vcOther.alpha       = 0;
  vcOther.vfilter     = VID_VFILTER_2TAP;
  vcOther.hfilter     = (otherChannel == VID_CHANNEL_MAIN) ? VID_HFILTER_4TAP : VID_HFILTER_NONE;
  for(i = 0; i < 5; i++) vcOther.reserved[i] = 0;
  
  if ( otherChannel == VID_CHANNEL_MAIN ) vcMain = &vcOther;
  else                                    vcOSD  = &vcOther;
}
      
// =================================================================================================

void yarUnsetSideBufferChannel()
{
  if ( otherChannel == -1) {
    return;
  }

  if ( otherChannel == VID_CHANNEL_MAIN) vcMain = NULL;
  else                                  vcOSD  = NULL;
}
      
// =================================================================================================

void yarDefineOtherChannel(int w, int h)
{
  int i;
  int pixType = 4;
  
  // Get the memory (freeing first if the dimensions changed)
  if ( otherBuffer && ( ( w != vcOtherW ) || ( h != vcOtherH ) ) )
  {
    free( otherBuffer );
    otherBuffer = NULL;
  }

  if ( otherBuffer == NULL )
  {
    otherBuffer = _MemAlloc( w * h * pixType, 512, kMemSDRAM );
    if ( otherBuffer == NULL ) {
      printf( "\nERROR! Could not allocate %d bytes for other buffer\n", w * h * pixType );
      return;
    }
  }

  vcOtherW = w;
  vcOtherH = h;

  otherChannel = (yarChannel == VID_CHANNEL_MAIN) ? VID_CHANNEL_OSD : VID_CHANNEL_MAIN;

  vcOther.dmaflags    = DMA_PIXEL_READ  | ((w/8)<<16) | (pixType<<4) | (1<<11);
  vcOther.base        = otherBuffer;
  vcOther.dest_xoff   = 0;
  vcOther.dest_yoff   = 0;
  vcOther.dest_width  = 720;
  vcOther.dest_height = 480;
  vcOther.src_xoff    = 0;
  vcOther.src_yoff    = 0;
  vcOther.src_width   = bufferW;
  vcOther.src_height  = bufferH;
  vcOther.clut_select = 0;
  vcOther.alpha       = 0;
  vcOther.vfilter     = VID_VFILTER_2TAP;
  vcOther.hfilter     = (otherChannel == VID_CHANNEL_MAIN) ? VID_HFILTER_4TAP : VID_HFILTER_NONE;
  for(i = 0; i < 5; i++) vcOther.reserved[i] = 0;
}

// =================================================================================================

void yarEnableOtherChannel()
{
  vcOtherActive = TRUE;
  
  if ( otherChannel == VID_CHANNEL_MAIN) vcMain = &vcOther;
  else                                  vcOSD  = &vcOther;
}
      
// =================================================================================================

void yarDisableOtherChannel()
{
  vcOtherActive = FALSE;
  
  if ( otherChannel == VID_CHANNEL_MAIN) vcMain = NULL;
  else                                  vcOSD  = NULL;
}
      
// =================================================================================================

void renderToOtherChannel()
{
  vcOtherRender = TRUE;
}

// =================================================================================================

void yarSetScreenFlash(int flash)
{
  screenFlash = flash;
}

// =================================================================================================

int yarGetScreenFlash()
{
  return screenFlash;
}

// =================================================================================================

void yarAddScreenFlash(int flash)
{
  screenFlash += flash;
  if ( screenFlash > 0xFF) screenFlash = 0xFF;
  if ( screenFlash < 0) screenFlash = 0;
}

// =================================================================================================

void yarSetScreenFade(int fade)
{
  screenFade = fade;
}

// =================================================================================================

void yarSetYarChannel(int channel)
{
  yarChannel = channel;
}
		   
// =================================================================================================

void yarSetClearMethod(int method, int param1, int param2, int param3)
{
  clrMethod = method;
  clrParam1 = param1;
  clrParam2 = param2;
  clrParam3 = param3;

  switch ( clrMethod )
  {
    case kClearCopyFade:
      clrParam2 = dmaFlagsWr;
      break;
    case kClearCopyTile:
      clrParam2 = DMA_PIXEL_WRITE | ( ( param2 / 8 ) << 16 ) | ( 4 << 4 );
      if ( param2 >= CLUSTER_WIDTH_LIMIT )
      {
	clrParam2 |= 1 << 11;  // set cluster bit for wide images
      }
      break;
  }
}

// =================================================================================================

// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO
//
// WAV functions (original source provided by VM Labs)
//
// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO

/*
 * Copyright (c) 2001 VM Labs, Inc.  All rights reserved.
 *
 * NOTICE: VM Labs permits you to use, modify, and distribute this file
 * in accordance with the terms of the VM Labs license agreement
 * accompanying it. If you have received this file from a source other
 * than VM Labs, then your use, modification, or distribution of it
 * requires the prior written permission of VM Labs.
*/

// =================================================================================================

typedef struct
{
	short			compression;
	short			channels;
	long			samplerate;
	long			bytes_per_second;
	short			block_alignment;
	short   		bits_per_sample;

} __attribute__ ((packed)) WAVE_Format;


typedef struct
{
	short			exponent;
	long			mantissa[2];

} __attribute__ ((packed)) ieeeDoubleFP80;


typedef struct
{
	short			channels;
	long			sample_frames;	
	short   		bits_per_sample;
	ieeeDoubleFP80	samplerate;
	long			compression;

} __attribute__ ((packed)) COMM_Chunk;

////////////////////////////////////////////////////////////////////////////
// Get a longword from an unaligned pointer
////////////////////////////////////////////////////////////////////////////

static inline long GetLong( void *l )
{
unsigned short *s;

	s = (unsigned short *)l;

	return (s[0] << 16) | s[1];
}

////////////////////////////////////////////////////////////////////////////
// Convert an unaligned 32-bit value between little endian & big endian
////////////////////////////////////////////////////////////////////////////

static inline void SwapEndian32(long *l)
{
unsigned char *c, c0, c1;

	c = (unsigned char *)l;
	c0 = c[0];
	
	c[0] = c[3];
	c1 = c[1];
	c[1] = c[2];
	c[2] = c1;
	c[3] = c0;
}

////////////////////////////////////////////////////////////////////////////
// Convert an unaligned 16-bit value between little endian & big endian
////////////////////////////////////////////////////////////////////////////

static inline void SwapEndian16(short *l)
{
unsigned char *c, c0, c1;

	c = (unsigned char *)l;
	c0 = c[0];
	c1 = c[1];

	c[0] = c1;
	c[1] = c0;
}

////////////////////////////////////////////////////////////////////////////
// Byte-swap a WAV file header & data.
//
// This routine is largely similar to PlayWAV since it has to parse the
// data in much the same way to figure out which parts to byte-swap
// and which parts to leave alone.  The byte-swapping is not integrated
// into PlayWAV() because we really only want to have to do it once.
////////////////////////////////////////////////////////////////////////////

int WaveToNWave(void *wavaddr)
{
  WAVE_Format *wav;
  long *l;
  short *pcm;
  long pcm_length;
  char *x;
  int frequency, i, num_samples;
  long *endfile;

  // We assume that "wavaddr" is long aligned here...
  l = (long *)wavaddr;

  // We don't bother verifying that this is a RIFF/WAVE file
  // since that should have been the test that sent us here.

  // Convert overall filesize & save it for loop testing
  SwapEndian32(&l[1]);
  endfile = (long *)((long)wavaddr + l[1]);
  
  // We could step past chunks looking for "fmt " but let's not.
  if( l[3] != 0x666d7420 )			// If the "fmt " chunk doesn't happen
    return(-1);					// here, we're screwed.
  
  
  // WAVE header would ordinarily start at the 5th longword
  wav = (WAVE_Format *)&l[5];
  
  // Convert all header fields from Little Endian to Big Endian
  SwapEndian16(&wav->compression);
  SwapEndian16(&wav->channels);
  SwapEndian32(&wav->samplerate);
  SwapEndian32(&wav->bytes_per_second);
  SwapEndian16(&wav->block_alignment);
  SwapEndian16(&wav->bits_per_sample);
  
  // Once we've done that, then test the header information to make sure
  // we don't have a sample format we can't handle anyway.  Note that if 
  // the WAVE is rejected by this test, the header is partially
  // converted already.  We could undo that, but it doesn't seem necessary.
  
  if( wav->compression != 1 )			// PCM compression all we can do
    return(-2);
  
  if( wav->bits_per_sample != 16 )		// We can only do 16-bit samples
    return(-3);
  
  if( wav->channels > 1 )			// We can only do MONO samples
    return(-4);	
  
  // Calculate NUON sample rate value.  0x1000 = 24000
  
  frequency = (wav->samplerate * 0x1000) / 24000;
  
  if( frequency > 0x10000 )			// Make sure sample rate isn't too high.
    return(-5);					// We only can go to about 1 million samples/sec.
  // Yes, that was a joke.
  
  // Set RIFF header to indicate that we've already converted everything
  // Do this AFTER verifying that the WAVE format is acceptible.
  
  l[2] = 0x4E574156;				// Change "WAVE" to "NWAV"
  
  // OK, now we've gotten the header figured out, let's
  // locate and convert the actual sample data.
  
  x = (char *)wavaddr + 20;			// Skip to just past "fmt " chunkname
  
  SwapEndian32(&l[4]);				// Convert chunksize value
  x += l[4];					// Add size of "fmt " chunk
  l = (long *)x;				// Reset pointer to what should be "data" chunk
  
  // OK, now we should be be pointing at the "data" chunk.
  // If the chunk at "x" is not "data" then it might be one of
  // the extended information chunks we mentioned earlier, as
  // those frequently happen before the data chunk.
  // So skip past each chunk until we find "data"
  
  while( GetLong(l) != 0x64617461 && (l < endfile) )	// Is it the "data" chunk?
    {
      SwapEndian32(&l[1]);			// byte-swap chunk size
      
      x = (char *)l;				// Not data chunk so
      x += 4;						// step past chunk name,
      x += GetLong(&l[1]);			// add size of chunk,
      l = (long *)x;				// And reset pointer to next chunk.
    } 
  
  // Make sure we found "data" and didn't walk off the end
  if( *l != 0x64617461 )			// If not "data"
    return(-1);					// then unsupported format
  
  SwapEndian32(&l[1]);				// Convert size of data chunk
  
  pcm_length = l[1];				// Get size of "data" chunk
  pcm = (short *)&l[2];				// Get address of data
  num_samples = pcm_length / 2;			// Get number of samples
  
  // Let us now convert the actual sample data
  
  for( i = 0; i < num_samples; i++ )
    SwapEndian16(pcm++);
  
  return(0);
}

////////////////////////////////////////////////////////////////////////////
// Decipher a WAV file and play the sound
// 
// Returns negative error number if sound cannot be played:
// 	-1 = Not valid WAV file, or has extra information we don't recognize
//  -2 = Not acceptible sound format or compression mode
//  -3 = Sample size is not recognized (uses 16-bit only)
//  -4 = Sample is not monophonic
//  -5 = Sample rate is out of range
////////////////////////////////////////////////////////////////////////////

int aNoteTable[12] = {
  1712,  // Taken from the S3M description (S3M.TXT)
  1616,
  1524,
  1440,
  1356,
  1280,
  1208,
  1140,
  1076,
  1016,
  960,
  907
};

int PlayWAV(void *wavaddr, int loop, PCMPOS *Pan, int volume, int note)
{
  long *l, *pcm, pcm_length;
  char *x;
  int frequency;
  WAVE_Format *wav;
  PCMHEAD WaveDefine;
  int result;
  long *endfile;

  assert(wavaddr);
  
  l = (long *)wavaddr;
  
  // Verify data as a WAV file
  if( l[0] != 0x52494646 )			// "RIFF"
    return(-1);
  
  // Get overall filesize & save it for loop testing
  endfile = (long *)((long)wavaddr + l[1]);
  
  if( l[2] != 0x57415645 && l[2] != 0x4E574156 )	// "WAVE" or "NWAV"
    return(-1);
  
  // See if the sample has already been converted from little-endian
  // to big endian format, and if not, then go convert it right now!
  
  if( l[2] != 0x4E574156 )			// If not "NWAV"
    {
      result = WaveToNWave(wavaddr);	// Go byte-swap from INTEL format
      
      if( result )				// Conversion will return non-zero 
	return(-2);				// if it's a format we don't like
      
      // Note that if the WAVE is rejected, the header may be partially
      // converted already.
    }
  
  // We presume that the "fmt " chunk starts at l[3] and that this
  // has been previously verified by WaveToNWave().
  // We could step past chunks looking for "fmt " but let's not.
  
  // Get sample rate out of WAVE header.
  // We've already determined in WaveToNWave() that the WAVE format
  // is OK, so we don't need to check most WAVE header info again.
  
  wav = (WAVE_Format *)&l[5];
  //  frequency = (wav->samplerate * 0x1000) / 24000;

  if ( note == -1) {
    frequency = wav->samplerate;
  } else {
    // From S3M.TXT
    //
    //        Table for note frequencies used by ST3:
    //
    //	  note:  C    C#   D    D#   E    F    F#   G    G#   A    A#   B
    //	period: 1712,1616,1524,1440,1356,1280,1208,1140,1076,1016,0960,0907
    //	
    //	middle octave is 4.
    //	
    //			 8363 * 16 * ( period(NOTE) >> octave(NOTE) )
    //	note_st3period = --------------------------------------------
    //	 		 middle_c_finetunevalue(INSTRUMENT)
    //			 
    //	note_herz=14317056 / note_st3period
    //
    // My simplification: 14317056 / period = (14317056 * baseFreq) / (8363 * 16 * N)
    //                                      = (107 * baseFreq) / N

    // On the Yaroze, note=48 means 22050Hz
    frequency = (107 * 22050) / (aNoteTable[note%12] >> (note/12));
    //    frequency = (107 * wav->samplerate) / (aNoteTable[note%12] >> (note/12));
    //  printf("old freq=%d  new freq=", wav->samplerate);
    //  printf("%d (note=%X, table=%d)\n", frequency, note, aNoteTable[note%12]);
  }
  
  frequency = (frequency * 0x1000) / 24000;
  
  x = (char *)wavaddr + 20;			// Skip to "fmt " chunk
  x += l[4];					// Add size of "fmt " chunk
  l = (long *)x;				// Reset pointer to what should be "data" chunk
  
  // If the chunk at "x" is not "data" then it might be one of
  // the extended information chunks we mentioned earlier, as
  // those frequently happen before the data chunk.
  
  while( GetLong(l) != 0x64617461 && (l < endfile) )	// Is it the "data" chunk?
    {
      x = (char *)l;				// Not data chunk so
      x += 4;							// step past chunk name,
      x += GetLong(&l[1]);			// add size of chunk,
      l = (long *)x;				// And reset pointer to next chunk.
    } 
  
  if( GetLong(l) != 0x64617461 )		// If not "data"
    return(-2);					// then unsupported format
  
  pcm_length = l[1];				// Get size of "data" chunk
  pcm = &l[2];					// Get address of data
  
  // OK, everything we did earlier was simply to get to the right location
  // for the data, and to figure out what the sample rate value should be.
  
  WaveDefine.PCMWaveBegin = (unsigned long)pcm;
  WaveDefine.PCMLength    = pcm_length / 2;
  WaveDefine.PCMLoopBegin = 0;
  WaveDefine.PCMLoopEnd   = pcm_length / 2;
  WaveDefine.PCMBaseFreq  = frequency;
  WaveDefine.PCMControl   = loop!=-1?1:0;

  //printf("%08X %d %d %d %08X %d\n", WaveDefine.PCMWaveBegin, WaveDefine.PCMLength, WaveDefine.PCMLoopBegin,  WaveDefine.PCMLoopEnd, WaveDefine.PCMBaseFreq, WaveDefine.PCMControl);
  return PCMPlaySample(-1, &WaveDefine, Pan, volume, 0);
}

int yarPlayWAV(void *wavaddr, short vol)
{
  PCMPOS pan;
  
  pan.PCMPanLR  = 0;
  pan.PCMPanFB  = 0;
  pan.PCMPanUD  = 0;
  pan.Reserved1 = 0;
  return PlayWAV(wavaddr, -1, &pan, vol << 23, -1);  // Yaroze Vol=0.16   NUON Vol=1.31
}

////////////////////////////////////////////////////////////////////////////
// Decipher an AIFF file and play the sound
// 
// Returns negative error number if sound cannot be played:
// 	-1 = Not valid AIFF file, or has extra information
//  -2 = Not acceptible sound format or compression mode
//  -3 = Sample size is not recognized (uses 16-bit only)
//  -4 = Sample is not monophonic
//  -5 = Sample rate is out of range
////////////////////////////////////////////////////////////////////////////

int PlayAIFF(void *wavaddr, int voice, PCMPOS *Pan, int volume, int echo )
{
long *l, *pcm, pcm_length;
char *x;
int frequency;
COMM_Chunk *comm;
PCMHEAD WaveDefine;
int		comm_size;
int		ieeeExponent, ieeeMantissa;
int		samplerate;
int		shiftamt;

//int		result;
//int		i1, i2;
//short	*s, *ip1, *ip2;
//int		*i;
long	*endfile;

	l = (long *)wavaddr;

	// Verify data as an AIFF file
	if( l[0] != 0x464F524D )			// "FORM"
		return(-1);

	// Get overall size of file for loop testing
	endfile = (long *)((long)wavaddr + l[1]);

	if( l[2] != 0x41494646 )			// "AIFF"
		return(-1);

	if( l[3] != 0x434F4D4D )			// "COMM"
		return(-1);

	comm_size = l[4];
    comm = (COMM_Chunk *)&l[5];
    
	if( comm_size >= 22 )				// Compression field doesn't exist if have small COMM chunk
	{
		if( comm->compression != 0x4E4F4E45 )	// compression = "NONE"
		{
			return(-2);
		}
	}

	if( comm->bits_per_sample != 16 )	// We can only do 16-bit samples
	{
		return(-3);
	}

	if( comm->channels > 1 )			// We can only do MONO samples
	{
		return(-4);	
	}
	
	ieeeExponent = comm->samplerate.exponent;
	ieeeMantissa = comm->samplerate.mantissa[0];

	shiftamt = (16414 - ieeeExponent);
	samplerate = ieeeMantissa >> 1;			// Do first shift
    samplerate &= 0x7FFFFFFF;				// Then make sure sign bit is clear
	samplerate >>= --shiftamt;				// Then do remaining shift

	frequency = (samplerate * 0x1000) / 24000;

	if( frequency > 0x10000 )			// Make sure sample rate isn't too high.
		return(-5);						// We only can go to about 1 million samples/sec.
										// Yes, that was a joke.

	x = (char *)wavaddr + 20;			// Skip to just past "COMM" chunk
	x += l[4];							// Add size of "COMM" chunk
	l = (long *)x;						// Reset pointer to what should be "SSND" chunk
		
	// Now we should be at SSND chunk.
#if 1		
	// Note that an AIFF file might have chunks of data
	// with information like author info, or copyright info,
	// etc.  The loop below will attempt to step past 
	// anything like that until it finds the SSND chunk 
	// where the sound sample data is stored.
	
	while( GetLong(l) != 0x53534e44 && (l < endfile) )	// Is it the "SSND" chunk?
	{
		x = (char *)l;					// Not SSND chunk so
		x += 4;							// step past chunk name,
		x += GetLong(&l[1]);			// add size of chunk,
		l = (long *)x;					// And reset pointer to next chunk.
	} 
#endif
	
	// Verify that the loop above didn't run off the end of the file

	if( GetLong(l) != 0x53534E44 )		// If not "SSND"
		return(-2);						// then unsupported format  

	pcm_length = GetLong(&l[1]);		// Get size of "SSND" chunk

	pcm_length -= 8;					// Subtract 8 extra bytes at beginning
	pcm = &l[4];						// Get address of data chunk + 8 extra bytes

    // OK, everything we did earlier was simply to get to the right location
	// for the data, and to figure out what the sample rate value should be.

    WaveDefine.PCMWaveBegin = (unsigned long)pcm;
    WaveDefine.PCMLength    = pcm_length / 2;
    WaveDefine.PCMLoopBegin = 0;
    WaveDefine.PCMLoopEnd   = pcm_length / 2;
    WaveDefine.PCMBaseFreq  = frequency;
    WaveDefine.PCMControl   = 0;

	return PCMPlaySample(voice, &WaveDefine, Pan, volume, echo );
}

// =================================================================================================

// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO
//
// Profiling helper functions
//
// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO

#define MAX_CHECKPOINTS 20

int aCheckpoint[MAX_CHECKPOINTS];
int aCheckpointWorst[MAX_CHECKPOINTS];
int aCheckpointThis[MAX_CHECKPOINTS];
static int checkpointCount = TRUE;
static int checkpointSamples = 0;
long cpUsecPrev;
int checkpointIndex = 0;

// =================================================================================================

void timeInit(int x)
{
  int i;
  int ms, us;
  int total, totalWorst;
  int targetFPS;

  //  targetFPS = 60 >> maxFrameRate;
  targetFPS = maxFrameRate;
  
  timeCheckpoint();
  
  if ( showCheckpoints != kCheckpointsOff) {
    perfShowPerfMon();
  }
  
  if ( devSystem && (_Controller[1].buttons & JOY_NUON) &&
      (curButtons & JOY_C_UP) && !(prevButtons & JOY_C_UP)) {
    showCheckpoints++;
    if ( showCheckpoints == kCheckpointsMax) {
      showCheckpoints = kCheckpointsOff;
    }
    printf("YARLIB: Checkpoints set to %s\n", aCheckpointsDesc[showCheckpoints]);
  }
  
  if ( checkpointSamples <= 0) {

    totalWorst = 0;
    for (i = 0; i < checkpointIndex; i++) {
      totalWorst += aCheckpointWorst[i];
    }
      
    total = 0;
    if ( showCheckpoints == kCheckpointsAvg) {
      printf("AVG:   ");
    }
    for (i = 0; i < checkpointIndex; i++) {
      total += aCheckpoint[i];
      aCheckpoint[i] /= targetFPS;
      ms = aCheckpoint[i] / 1000;
      us = (aCheckpoint[i] % 1000) / 100;
      if ( showCheckpoints == kCheckpointsAvg) {
	if ( i == (checkpointIndex-1)) {
	  printf(" (%d.%dms)", ms, us);
	} else {
	  if ( ms < 2) {
	    printf(" ~");
	  } else {
	    printf(" %d.%dms", ms, us);
	  }
	}
      }
    }
    if ( total) {
      total /= targetFPS;
      ms = total / 1000;
      us = (total % 1000) / 100;
      if ( showCheckpoints == kCheckpointsAvg) {
	printf(" = %d.%dms", ms, us);
      }
    }
    if ( showCheckpoints == kCheckpointsAvg) {
      printf("\n");
    }
    if ( showCheckpoints == kCheckpointsWorst) {
      printf("WORST: ");
      total = 0;
      for (i = 0; i < checkpointIndex; i++) {
	total += aCheckpointWorst[i];
	ms = aCheckpointWorst[i] / 1000;
	us = (aCheckpointWorst[i] % 1000) / 100;
	if ( i == (checkpointIndex-1)) {
	  printf(" (%d.%dms)", ms, us);
	} else {
	  if ( ms < 2) {
	    printf(" ~");
	  } else {
	    printf(" %d.%dms", ms, us);
	  }
	}
      }
      ms = total / 1000;
      us = (total % 1000) / 100;
      printf(" = %d.%dms\n", ms, us);
      //      SPRPrintRendererCounters();
      //      SPRResetRendererCounters();
      //      printf("lastfps=%d\n", lastfps);
    }

    checkpointCount = FALSE;
    checkpointSamples = targetFPS;

    for (i = 0; i < MAX_CHECKPOINTS; i++) {
      aCheckpoint[i]      = 0;
      aCheckpointThis[i]  = 0;
      aCheckpointWorst[i] = 0;
    }
    
  } else {
    checkpointSamples--;
    checkpointCount = TRUE;
    
    // See if this frame was the worst so far
    total = 0;
    totalWorst = 0;
    for (i = 0; i < checkpointIndex; i++) {
      total += aCheckpointThis[i];
      totalWorst += aCheckpointWorst[i];
    }
    if ( total > totalWorst) {
      for (i = 0; i < checkpointIndex; i++) {
	aCheckpointWorst[i] = aCheckpointThis[i];
      }
    }

    // Initialize this for the new frame
    _TimeElapsed(NULL, &cpUsecPrev);
  }
  
  checkpointIndex = 0;
}

// =================================================================================================

void timeCheckpoint()
{
  long usec;
  static int printed = FALSE;

  if ( checkpointCount != 0 )
  {
    if ( checkpointIndex < MAX_CHECKPOINTS )
    {
      _TimeElapsed(NULL, &usec);
      if ( usec < cpUsecPrev )
      {
	usec += 1000000;
      }
      usec -= cpUsecPrev + TIME_ELAPSED_DELAY;

      aCheckpoint[checkpointIndex] += usec;
      aCheckpointThis[checkpointIndex] = usec;
      checkpointIndex++;
      _TimeElapsed(NULL, &cpUsecPrev);
    }
    else
    {
      if ( printed == 0 )
      {
	printed = TRUE;
	printf("YARLIB ERROR: Ran out of time checkpoints (max=%d)\n", MAX_CHECKPOINTS);
      }
    }
  }
}

// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO
//
// Yaroze library functions
//
// Oo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oOo.oO
int vsyncCount = 0;

int myVSync(int mode)
{
  int i;
  int x, y;
  static int fps = 0;
  static int vsyncStart;
  static unsigned int prevFrame = -1;
  int returnValue;
  int debug = FUNC_TRACE;
  unsigned int thisFrame = _VidSync(-1);
  int frameDiff;
  int swapThisFrame;
  int targetFrameCount = frameRatePatternCur & FRAMERATE_PATTERN_MASK;

  // Initialize the current frame number the first time through
  if ( prevFrame == -1 )
  {
    prevFrame = _VidSync(-1);
  }

  readControllers();
  ssCheck();
  //  screenshotCheck(screenW, screenH, dmaFlagsRd);
    
  // Calls a non-reentrant bios routine
  perfEventLog( kEventVSync, buffReady, buffDisp, 0xFFFFFFFF, 0xFFFFFFFF );

  if ( mode == 0 )
  {
    if ( buffReady > buffDisp )
    {
      // Assume no swap for now
      swapThisFrame = FALSE;

      // Get the number of frames that passed since the last time we swapped
      frameDiff = thisFrame - prevFrame;

      // If the frame difference is negative then the counter must have wrapped.
      // So just punt and swap anyway.  Only happens if you keep a 60 fps game 
      // running for 136 straight years :)
      if ( frameDiff < 0 )
      {
	swapThisFrame = TRUE;
      }

      //      printf("%08X %d %d\n", frameRatePatternCur, frameDiff, targetFrameCount);

      if ( frameDiff > targetFrameCount )
      {
	// Spent more frames than expected - start the counter over
	swapThisFrame = TRUE;
	frameRatePatternCur = frameRatePatternOrig;
      }
      else if ( frameDiff == targetFrameCount )
      {
	// Number of frames matches what we want so do the swap
	swapThisFrame = TRUE;
	
	// Advance the frame rate pattern and reset it if necessary
	frameRatePatternCur >>= FRAMERATE_PATTERN_SIZE;
	if ( frameRatePatternCur == 0 )
	{
	  frameRatePatternCur = frameRatePatternOrig;
	}
      }
      
      //      if ( (prevFrame == -1) || ((thisFrame - prevFrame) >= maxFrameRate)) {
      if ( swapThisFrame != 0 )
      {
	prevFrame = thisFrame;
	buffDisp++;
	perfEventParam( 1, buffDisp );

	if ( numFB == QUAD_BUFFER )
	{
	  dispBuffer++;
	  if ( dispBuffer >= numFB )
	  {
	    dispBuffer = 0;
	  }
	  //	  if ( debug && (numFB == DOUBLE_BUFFER)) {
	  //	    printf("YARLIB myVSync(): drawBuffer=%d(FB=%d)  dispBuffer=%d(FB=%d)\n",
	  //		   drawBuffer, aFBIndex[drawBuffer], dispBuffer, aFBIndex[dispBuffer]);
	  //	  }
      
	  // Do _VidConfig rather than _VidChangeBase because the other channel might have changed too
	  vcYar.base = aFB[aFBIndex[dispBuffer]].ptr;
	  //	if ( debug != 0 ) printf("YARLIB myVSync(): New FB base=%08X\n", vcYar.base);
	  _VidConfig(&vd, vcMain, vcOSD, 0L);

	  perfEventParam( 2, dispBuffer );
	  perfEventParam( 3, (int) vcYar.base );
	}

	// Compute the average frame rate by counting the number of frames drawn in 60 syncs
	if ( fps == -1 )
	{
	  vsyncStart = thisFrame;
	  fps = 1;
	}
	else if ( ( numFB == QUAD_BUFFER ) || ( mode == 0 ) )
	{
	  if ( ( thisFrame - vsyncStart ) >= 60 )
	  {
	    lastfps = fps;
	    fps = -1;
	  }
	  else
	  {
	    fps++;
	  }
	}
      }
      
      //      vsyncCount = _VidSync(-1);
    }
    
    if ( numFB == QUAD_BUFFER )
    {
      return vsyncCount;
    }
  
  }
  else if ( mode > 0 )
  {
    printf("YARLIB ERROR: Can't handle VSync(%d)\n", mode);
  }

  if ( mode < 0 )
  {
    // FUNCTION: "Absolute time from program activation is returned in vertical
    //            synchronization interval units."
    // RETURN:   "Time elpased from program activation (vertical return unit)."

    vsyncCount = _VidSync(-1);

    returnValue = vsyncCount;
  }
  else if ( mode == 0)
  {
    // FUNCTION: "Block until vertical synchronization occurs."
    // RETURN:   "Time elpased from point in time when VSync was previously
    //            called (horizontal return unit)."

    if ( ( maxFrameRate == 60 ) || ( ( _VidSync( -1 ) - vsyncCount ) >= maxFrameRate ) )
    {
      vsyncCount = _VidSync(-1);
      if ( numFB == DOUBLE_BUFFER )
      {
	while ( _VidSync(-1) == vsyncCount );
      }
    }
    else
    {
      while ( ( _VidSync( -1 ) - vsyncCount ) < maxFrameRate );
    }

    vsyncCount = _VidSync( -1 );

    // NUON does not keep track of horizontal syncs so return zero instead.
    returnValue = 0;
  }
  else if ( mode == 1 )
  {
    // FUNCTION: "The time elapsed from the point in time when VSync() was
    //            previously called is returned in units of one horizontal
    //            synchronization interval."
    // RETURN:   "Time elpased from point in time when VSync was previously
    //            called (horizontal return unit)."

    vsyncCount = _VidSync( -1 );

    // NUON does not keep track of horizontal syncs so return zero instead.
    returnValue = 0;
  }
  else  // mode > 1
  {
    // FUNCTION: "Counting from the point in time when VSync() was previously
    //            called and blocking up to N times the occurance of vertical
    //            synchronization."
    // RETURN:   "Time elpased from point in time when VSync was previously
    //            called (horizontal return unit)."

    while ( ( _VidSync( -1 ) - vsyncCount ) < mode ) _VidSync( 1 );
    vsyncCount = _VidSync( -1 );

    // NUON does not keep track of horizontal syncs so return zero instead.
    returnValue = 0;
  }

  return returnValue;
}

// When quad buffering, a video interrupt causes something similar to VSync(0)
void intVSync()
{
  myVSync(0);
}

int VSync(int mode)
{
  static int init = 0;
  int thisFrame = _VidSync( -1 );
  long time1, time2;
  int debug = FUNC_TRACE;

  if ( debug != 0 )
  {
    printf( "YARLIB VSync(%d)\n", mode );
  }
  ssPrintMsg();

  if ( strToPrint[0] != 0 )
  {
    printf( "%s", strToPrint );
    strToPrint[0] = 0;
  }

  if ( devSystem && ( _Controller[1].buttons & JOY_NUON ) &&
       ( curButtons & JOY_C_RIGHT ) && ( ( prevButtons & JOY_C_RIGHT ) == 0 ) )
  {
    perfEventPrint(aEventString);
  }

  // Initialize interrupt vector when quad buffering
  if ( numFB == DOUBLE_BUFFER )
  {
    return myVSync( mode );
  }
  else if ( numFB == QUAD_BUFFER )
  {
    if ( mode == -1 )
    {
      return myVSync( -1 );
    }
    else
    {
      if ( init == 0 )
      {
	_IntSetVector( kIntrVideo, intVSync );
	init = 1;
      }

      /*
      // When capping frame rate, kill time until the blank occurs
      if ( maxFrameRate == MAXFRAMERATE_30FPS) {
	if ( thisFrame == _VidSync(-1)) {
	  _TimeElapsed(NULL, &time1);
	  while (thisFrame == _VidSync(-1)) {
	    _TimeElapsed(NULL, &time2);
	  }
	  extraTime = time2 - time1;
	  if ( time2 < time1) extraTime += 1000000;
	} else {
	  extraTime = 0;
	}
      }
      */
      
    }
  }
  
  return 0;
}

// =================================================================================================

int VSyncCallback(void (*f)()) 
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

DISPENV *PutDispEnv(DISPENV *env)
{
  vcYar.dest_xoff = env->screen.x;
  vcYar.dest_yoff = env->screen.y;
}

// =================================================================================================

DRAWENV *PutDrawEnv(DRAWENV *env)
{
}

// =================================================================================================

int ClearImage(RECT *rect, u_char r, u_char g, u_char b, int convert)
{
  int x, y, h, w;
  int lastX, lastY;
  int color;
  int debug = FUNC_TRACE;

  if ( debug != 0 ) printf("YARLIB ClearImage((%d,%d,%d,%d), %d, %d, %d, %d)\n",
		    rect->x, rect->y, rect->w, rect->h, r, g, b, convert);
    
  if ( convert) {
    // Convert from RGB to YCrCb if necessary.  Only do this if the input values are true RGB,
    // and not values for 4-bit or 8-bit sprites.
    rgb2ycrcb(&r, &g, &b);
    color = ((b & 0xF8) >> 3) | ((g & 0xF8) << 2) | ((r & 0xF8) << 8);
  } else {
    color = ((r & 0xF8) >> 3) | ((g & 0xF8) << 2) | ((b & 0xF8) << 7);
  }
  
  color |= color << 16;

  lastX = rect->x + rect->w;
  lastY = rect->y + rect->h;
  

  for (x = rect->x; x < lastX; x += w) {
    for (y = rect->y; y < lastY; y += h) {
      w = 8;
      if ( (x + w) > lastX) w = lastX - x;
      h = 8;
      if ( (y + h) > lastY) h = lastY - y;

      _raw_plotpixel(YAROZE_DMA_FLAGS_WR, yarozeBuff, (w<<16)|x, (h<<16)|y, color);
    }
  }

  checkOverlap(rect->x, rect->y, rect->w, rect->h);
}

// =================================================================================================

int DrawSync(int mode)
{
  int debug = FUNC_TRACE;
  
  perfEventLog(kEventDrawSyncStart, mode, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF);
  SPRWait();
  //  _DCacheSync();
  _DCacheFlush();
  if ( debug != 0 ) printf("YARLIB DrawSync() -------------------------------------------------------\n");
  perfEventLog(kEventDrawSyncEnd, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF);
}

// =================================================================================================

int FntOpen(int x, int y, int w, int h, int isbg, int n)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void KanjiFntClose(void)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

int KanjiFntOpen(int x, int y, int w, int h, int dx, int dy, int cx, int cy,
		 int isbg, int n)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

int Krom2Tim(u_char *sjis, u_long *taddr, int dx, int dy, int cdx, int cdy,
	     u_int fg, u_int bg)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

int Krom2Tim2(u_char *sjis, u_long *taddr, int dx, int dy, int cdx, int cdy,
	      u_int fg, u_int bg)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

int LoadImage(RECT *rect, u_long *p, int convert)
{
  int i;
  int x, y, w, h;
  unsigned char *pLocal = (unsigned char *) p;
  unsigned char *ptr = NULL;
  unsigned short *src, *dest;
  unsigned char r, g, b;
  int skipCount;
  int numScalars;
  int offset;

  //  _DCacheSync();
  _DCacheFlush();

  for (y = 0; y < rect->h; y += h) {
    h = getOptimalH(rect, y, 64, 0);
    
    for (x = 0; x < rect->w; x += w) {
      w = getOptimalW(rect, x, 64, h, 2);
      
      // If we're offset then need to skip some data after reading
      skipCount = (unsigned long) pLocal & 0x3;

      // Round to next lowest address
      ptr = (char *) ((unsigned long) pLocal & 0xFFFFFFFC);

      // Get number of scalars to read.
      // Round up to ensure we get them all.
      // If the address is not on a scalar boundary, read one more scalar.
      numScalars = w * h;
      if ( skipCount) numScalars++;
      if ( numScalars & 0x1) numScalars++;
      numScalars >>= 1;

      // Get # of longs by rounding up the number of words
      _DMALinear((numScalars<<16)|(1<<13), ptr, localScratch);

      // Convert to YCrCb if necessary
      if ( convert) {
        src  = (unsigned short *) (localScratch + skipCount);
        dest = (unsigned short *) localScratch;
        for (i = 0; i < (w*h); i++, src++, dest++) {
//	  *src = ((*src << 8) & 0xFF00) | ((*src >> 8) & 0x00FF);
	  //	  printf("%04X", *src);
          r = (*src << 3) & 0xF8;
          g = (*src >> 2) & 0xF8;
          b = (*src >> 7) & 0xF8;
          rgb2ycrcb(&r, &g, &b);
          *dest = (*src >> 5) & 0x0400;  // transparency bit
          *dest |= ((r & 0xF8) << 8) | ((g & 0xF8) << 2) | ((b & 0xF8) >> 3);  // YCrCb
	  //	  printf("=%04X ", *dest);
        }
      } else if ( skipCount) {
        src  = (unsigned short *) (localScratch + skipCount);
        dest = (unsigned short *) localScratch;
        for (i = 0; i < (w*h); i++, src++, dest++) *dest = *src;
      }

      offset = 0;

      // Bilinear uses # of pixels, not # of longs
      _DMABiLinear(YAROZE_DMA_FLAGS_WR, yarozeBuff,
		   (w<<16) | (rect->x+x),
		   (h<<16) | (rect->y+y),
		   localScratch + offset);
      
      //      ptr += h*w*2;
      pLocal += h*w*2;
    }
  }

  checkOverlap(rect->x, rect->y, rect->w, rect->h);
}

// =================================================================================================

int MoveImage(RECT *rect, int newX, int newY)
{
  int i, x, y, w, h;
  short *ptr;
  int srcFB = -1, destFB = -1;
  unsigned long *ptrLong;
  int debug = FUNC_TRACE;
  
  if ( debug != 0 ) printf("YARLIB MoveImage(rect=(%d,%d,%d,%d), newX=%d, newY=%d)\n",
		    rect->x, rect->y, rect->w, rect->h, newX, newY);
  
  // Check if source or destination areas lie in a frame buffer
  for (i = 0; i < MAX_FB; i++) {

    if ( aFB[i].ptr) {

      if ( ((rect->x < (aFB[i].x + screenW16)) && ((rect->x + rect->w) > aFB[i].x)) &&
	  ((rect->y < (aFB[i].y + screenH  )) && ((rect->y + rect->h) > aFB[i].y))) {
	srcFB = i;
	if ( debug != 0 ) printf("YARLIB MoveImage(): Source FB=%d (%08X)\n", i, aFB[i].ptr);
      }
      if ( ((newX < (aFB[i].x + screenW16)) && ((newX + rect->w) > aFB[i].x)) &&
	  ((newY < (aFB[i].y + screenH  )) && ((newY + rect->h) > aFB[i].y))) {
	destFB = i;
	if ( debug != 0 ) printf("YARLIB MoveImage(): Destination FB=%d (%08X)\n", i, aFB[i].ptr);
      }
    }
  }

  // Special case frame buffer to frame buffer transfers.
  if ( (srcFB != -1) && (destFB != -1))
  {
    for (y = 0; y < rect->h; y++)
    {
      for (x = 0; x < rect->w; x += 16)
      {
	w = 16;
	if ( (x + w) > rect->w)
	{
	  w = rect->w - x;
	}
	_DMABiLinear(dmaFlagsRd, aFB[srcFB].ptr,
#ifdef USE_BORDERX
		     (w<<16) | ((rect->x - aFB[srcFB].x + x + borderX)<<0),
#else
		     (w<<16) | ((rect->x - aFB[srcFB].x + x)<<0),
#endif
		     (1<<16) | ((rect->y - aFB[srcFB].y + y          )<<0),
		     localScratch);

	_DMABiLinear(dmaFlagsWr, aFB[destFB].ptr,
#ifdef USE_BORDERX
		     (w<<16) | ((newX - aFB[destFB].x + x + borderX)<<0),
#else
		     (w<<16) | ((newX - aFB[destFB].x + x)<<0),
#endif
		     (1<<16) | ((newY - aFB[destFB].y + y          )<<0),
		     localScratch);
      }
    }
    return;
  }

  // Also special case frame buffer to VRAM transfers
  if ( srcFB != -1 )
  {
    for (y = 0; y < rect->h; y++)
    {
      for (x = 0; x < rect->w; x += 16)
      {
	w = 16;
	if ( (x + w) > rect->w)
	{
	  w = rect->w - x;
	}
	
	if ( bufferMode == BUFFER_MODE_16BIT)
	{
	  _DMABiLinear(dmaFlagsRd, aFB[srcFB].ptr,
#ifdef USE_BORDERX
		       (w<<16) | ((rect->x - aFB[srcFB].x + x + borderX)<<0),
#else
		       (w<<16) | ((rect->x - aFB[srcFB].x + x)<<0),
#endif
		       (1<<16) | ((rect->y - aFB[srcFB].y + y          )<<0),
		       localScratch);

	  // Move STP bit
	  ptrLong = (unsigned long *) localScratch;
	  for (i = (w); i; i--, ptrLong++)
	  {
	    if ( (ptrLong[0] & 0xFFFFFF00) == 0x10808000)
	    {
	      ptrLong[0] ^= 0x1;  // STP bit is swapped for black pixels
	    }
	    if ( ptrLong[0] & 0x00000001)
	    {
	      ptrLong[0] = (ptrLong[0] & ~0x00000001) | 0x04000000;
	    }
	  }

	  _DMABiLinear(YAROZE_DMA_FLAGS_WR2, yarozeBuff,
		       (w<<16) | ((newX + x)<<0),
		       (1<<16) | ((newY + y)<<0),
		       localScratch);
	}
      }
    }
    return;
  }
  
  for (y = 0; y < rect->h; y += h)
  {
    h = getOptimalH(rect, y, 64, 0);
  
    for (x = 0; x < rect->w; x += w)
    {
      w = getOptimalW(rect, x, 64, h, 2);
     
      _DMABiLinear(YAROZE_DMA_FLAGS_RD, yarozeBuff,
		   (w<<16)|((rect->x+x)<<0),
		   (h<<16)|((rect->y+y)<<0),
		   localScratch);

#if ( 0)
      if ( yarlibDebug)
      {
	for (i = 0, ptr = (short*) localScratch; i < (w * h); i++, ptr++)
	  *ptr = 0x1234;
      }
#endif
      
      _DMABiLinear(YAROZE_DMA_FLAGS_WR, yarozeBuff,
		   (w<<16)|((newX+x)<<0),
		   (h<<16)|((newY+y)<<0),
		   localScratch);
    }
  }

  checkOverlap(newX, newY, rect->w, rect->h);
}

// =================================================================================================

int ResetGraph(int mode)
{
  SPRWait();
}

// =================================================================================================

int StoreImage(RECT *rect, volatile u_long *p, int convert)
{
  int x, y, w, h;
  char *ptr = NULL;
  unsigned short *conv;
  int i;
  unsigned char y_, cr, cb;

  //  _DCacheSync();
  _DCacheFlush();
  
  //  printf("StoreImage()\n");
  
  ptr = (char *) p;

  for (y = 0; y < rect->h; y += h) {
    h = getOptimalH(rect, y, 64, 0);
  
    for (x = 0; x < rect->w; x += w) {
      w = getOptimalW(rect, x, 64, h, 2);

      // Bilinear uses # of pixels, not # of longs
      _DMABiLinear(YAROZE_DMA_FLAGS_RD, yarozeBuff,
		   (w<<16)|((rect->x+x)<<0),
		   (h<<16)|((rect->y+y)<<0),
		   localScratch);
      
#if ( 0)
      if ( yarlibDebug) {
	for (i = 0; i < w*h; i++) {
	  printf("\nStoreImage() Before %d: %04X", i, ((unsigned short *) localScratch)[i]);
	}
      }
#endif
      
      // Convert back to RGB if necessary
      if ( convert) {
        for (i = 0, conv = (unsigned short *) localScratch; i < (w*h); i++, conv++) {
          y_ = (*conv >> 8) & 0xF8;
          cr = (*conv >> 2) & 0xF8;
          cb = (*conv << 3) & 0xF8;
          ycrcb2rgb(&y_, &cr, &cb);
          *conv = (*conv << 5) & 0x8000;  // transparency bit
          *conv |= ((cb & 0xF8) << 7) | ((cr & 0xF8) << 2) | ((y_ & 0xF8) >> 3);  // BGR
//	  *conv = ((*conv << 8) & 0xFF00) | ((*conv >> 8) & 0x00FF);
	  //	  printf("%04X ", *conv);
        }
      }
      
#if ( 0)
      if ( yarlibDebug) {
	for (i = 0; i < w*h; i++) {
	  printf("\nStoreImage() After %d: %04X", i, ((unsigned short *) localScratch)[i]);
	}
      }
#endif
      
      // Get # of longs by rounding up the number of words
      _DMALinear(((((w+1)>>1)*h)<<16), ptr, localScratch);

      ptr += h*w*2;

    }
  }
  
  _DCacheFlush();
}

// =================================================================================================

u_long *FntFlush(int id)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

u_long *KanjiFntFlush(int id)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

u_short GetClut(int x, int y) 
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

u_short GetTPage(int tp, int abr, int x, int y) 
{
  return((x >> 6) + ((y >> 8) << 4));
}

// =================================================================================================

void FntLoad(int tx, int ty)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void SetDispMask(int mask)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

int FntPrint()
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

int KanjiFntPrint()
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void    GsInit3D(void)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void GsInitGraph(unsigned short x, unsigned short y,
		 unsigned short intmode, unsigned short dith,
		 unsigned short vram)
{
  int i;
  int bpp;
  int pixType;

  int debug = 0;

  // If resolution is too large, scale it down
  dispScale = 0;
  if ( (x > 320) && (vram != BUFFER_MODE_24BIT)) {
    x >>= 1;
    y >>= 1;
    dispScale = 1;
  }

  bufferMode = vram;
  screenW = x;
  screenW16 = (bufferMode == BUFFER_MODE_16BIT) ? x : (x + (x>>1));
  screenH = y;

  _VidQueryConfig(&vd);

  //  bufferW = (screenW > 360) ? 720 : 360;
  //  bufferH = (screenW > 360) ? 480 : 240;
  bufferW = ( screenW > 360 ) ? vd.dispwidth  : ( vd.dispwidth >> 1 );
  //  bufferH = (screenW > 360) ? vd.dispheight : (vd.dispheight>>1);
  //  bufferW = (screenW > 320) ? 640 : 320;
  bufferH = ( screenW > 320 ) ? 512 : 256;

  vd.bordcolor = YCrCb32_LIGHT_BLUE; // YCrCb32_BLACK;

#if 1
  if ( bufferW > (vd.dispwidth>>1)) {
    borderX = vd.dispwidth;
  } else {
    borderX = vd.dispwidth>>1;
  }
  borderX = (borderX - screenW) >> 1;
#else
  borderX = 0;
#endif

  SPRSetOffset(borderX, -1);
  //  borderX = 0;

  // NUON sprite engine only handles 32-bit sprites
  pixType = 4;
  dmaFlagsRd = DMA_PIXEL_READ  | ( ( bufferW / 8 ) << 16 ) | ( pixType << 4 ) | ( 1 << 11 );
  dmaFlagsWr = DMA_PIXEL_WRITE | ( ( bufferW / 8 ) << 16 ) | ( pixType << 4 ) | ( 1 << 11 );

  vcYar.dmaflags    = debug ? YAROZE_DMA_FLAGS_RD : dmaFlagsRd;
  vcYar.base        = debug ? yarozeBuff : NULL;
  vcYar.dest_xoff   = -1;  // doesn't seem to work?
  vcYar.dest_yoff   = -1;
  vcYar.dest_width  = vd.dispwidth;
  vcYar.dest_height = vd.dispheight;
  vcYar.src_xoff    = debug ? 304 : 0;
  vcYar.src_yoff    = 0;
  vcYar.src_width   = debug ? 640 : bufferW;
  vcYar.src_height  = debug ? 480 : bufferH;
  vcYar.clut_select = 0;
  vcYar.alpha       = 0;
  vcYar.vfilter     = VID_VFILTER_2TAP;
  vcYar.hfilter     = (yarChannel == VID_CHANNEL_MAIN) ? VID_HFILTER_4TAP : VID_HFILTER_NONE;
  for(i = 0; i < 5; i++) vcYar.reserved[i] = 0;

  if ( yarChannel == VID_CHANNEL_MAIN) vcMain = &vcYar;
  else                                vcOSD  = &vcYar;

  /*
  for (i = 0; i < numFB; i++) {
    YarFillRect(0, 0, bufferW, bufferH, YCrCb32_BLACK, i);
  }
  */

  _VidConfig(&vd, vcMain, vcOSD, 0L);
  //  printf("vc=%d\n", _VidConfig(&vd, vcMain, vcOSD, 0L));

  /*
  if ( debug != 0 )
    _VidSetup(yarozeBuff, (DMA_PIXEL_READ | ((1024/8)<<16) | (2<<4) | (1<<11)),
	      720, 480, VID_VFILTER_2TAP);
  else
    _VidSetup(frameBuffer[0], dmaFlagsRd, screenW, screenH, VID_VFILTER_2TAP);
  */
}

// =================================================================================================

void    GsMapModelingData(unsigned long *p)
{
}

// =================================================================================================

void    GsSetProjection(long h)
{
}

// =================================================================================================

int     GsSetFlatLight(int id, GsF_LIGHT * lt)
{
}

// =================================================================================================

void    GsSetLightMode(int mode)
{
}

// =================================================================================================

void    GsSetFogParam(GsFOGPARAM * fogparm)
{
}

// =================================================================================================

void    GsSetAmbient(long r, long g, long b)
{
}

// =================================================================================================

void    GsDrawOt(GsOT * ot)
{
  int tpage;
  sImage *img;
  void *fb;
  int w, h;
  unsigned long dmaflags;
  int debug = FUNC_TRACE;

  if ( debug != 0 ) printf( "YARLIB GsDrawOt(%08X=%d)\n", ot, yarGetOTIndex( ot ) );

  //  if ( totalImgAlloc > IMG_DEALLOC_LIMIT)
  //    freeImageMemory(kDeallocOld, NULL);

  // Regenerate images that are dirty, but only if they are used this frame.
  for ( tpage = 0; tpage < 32; tpage++ )
  {
    for ( img = aImage[tpage]; img; img = img->next )
    {
      //      if ( ((img->uvwh >> 24) & 0xFF) == 0xA4) {
      //	printf("Img uvwh=%08X\n", img->uvwh);
      //      }
      if ( ( img->flags & kImgFlagDirty ) && !img->age )
      {
        generateImage( tpage, img );
      }
      img->age++;
    }
  }

  if ( vcOtherRender )
  {
    fb = vcOther.base;
    w  = vcOtherW;
    h  = vcOtherH;
    dmaflags = vcOther.dmaflags & ~DMA_READ_BIT;
  }
  else if ( sideRender )
  {
    fb = sideBuffer.ptr;
    w  = sideBufferW;
    h  = sideBufferH;
    dmaflags = dmaFlagsWr;
  }
  else
  {
    fb = aFB[aFBIndex[drawBuffer]].ptr;
    w  = vcYar.src_width;
    h  = vcYar.src_height;
    dmaflags = dmaFlagsWr;
  }

  if ( debug != 0 )
  {
    printf( "YARLIB GsDrawOt(): FB=%08X\n", fb );
  }

  SPRSetDestScreen2( fb, dmaflags, 0, 0, w-1, h-1, clrMethod, clrParam1, clrParam2, clrParam3 );
  vcOtherRender = FALSE;
  sideRender = FALSE;

  if ( libSpriteHang ) clrScreen |= 0x10;
  SPRDraw( clrScreen, 0, yarGetOTIndex( ot ) );
  clrScreen = FALSE;

  perfEventLog( kEventDrawOT, drawBuffer, yarGetOTIndex(ot), (int) fb, 0xFFFFFFFF );

  if ( debug != 0 ) printf( "YARLIB GsDrawOt() ends\n" );
  if ( yarlibMemDebug ) printf( "-----\n" );
}

// =================================================================================================

void    GsSetWorkBase(PACKET * outpacketp)
{
  // Does nothing in NUON environment
}

// =================================================================================================

void    GsSortObject4(GsDOBJ2 * objp, GsOT * ot, int shift, u_long * scratch)
{
}

// =================================================================================================

void yarSortPointYCrCb(int x, int y, int _y, int cr, int cb, GsOT *ot, unsigned short pri)
{
  unsigned long color;

  color = (_y << 24) | (cr << 16) | (cb << 8);

  SPRAddPoint(x, y, color, 0xFFFFFFFF - pri, yarGetOTIndex(ot));
}

// =================================================================================================

void yarSortPoint(int x, int y, int r, int g, int b, GsOT *ot, unsigned short pri)
{
  unsigned char _y, cr, cb;
  unsigned long color;

  _y = r;
  cr = g;
  cb = b;

  rgb2ycrcb(&_y, &cr, &cb);

  yarSortPointYCrCb( x, y, _y, cr, cb, ot, pri );
}

// =================================================================================================

SPRITE* SortSprite(GsSPRITE *sp, GsOT * ot, unsigned short pri, int fast)
{
  sImage *img;
  SPRITE *retVal = NULL;
  SPRITE *sprNUON = NULL;
  static int cnt1 = 0, cnt2 = 0, cnt3 = 0, cnt4 = 0;

  int crc;
  unsigned long *ptr;
  int i;

  // If using SPEEDSCALE be sure to only draw sprites the last iteration
  if ( _frame != 0 )
  {
    if ( yarlibDebug != 0 )
    {
      printf("oops\n");
      return;
    }
  }

  // No sprite to display if dimension is zero
  if ( ( sp->w == 0 ) || ( sp->h == 0 ) )
  {
    return;
  }

  if ( ( sp->attribute & ( SP_HINT_GOT_IMAGE | SP_HINT_PERM_IMAGE ) ) ==
       ( SP_HINT_GOT_IMAGE | SP_HINT_PERM_IMAGE ) )
  {
    img = (sImage*) sp->img;
  }
  else
  {
    img = allocImage( sp );
  }
  
  sp->img = (void*) img;
  sp->attribute &= ~SP_HINT_GOT_IMAGE;

  if ( img != NULL )
  {
    img->age = 0;
    sp->attribute |= SP_HINT_GOT_IMAGE;
    
    // Convert the Yaroze GsSPRITE* to a NUON SPRITE*
    sprNUON = getNUONSprite( sp, img, ot, pri, fast );

    if ( sprNUON != NULL )
    {
      // Scale the sprite based on our display scale.  If a game is meant to run at 640x480 then
      // setting dispScale to 1 will run it at 320x240.
      sprNUON->x >>= dispScale;
      sprNUON->y >>= dispScale;
#ifdef USE_BORDERX
      if ( vcOtherRender == 0 )
      {
	sprNUON->x += borderX;
      }
#endif
      if ( ( ( SPRITE_PRESCALE == 0 ) || ( img->flags & kImgFlagNoPrescale ) ) &&
	   !( img->flags & kImgFlagPrescale ) ) {
	sprNUON->xscale >>= dispScale;
	sprNUON->yscale >>= dispScale;
      }
      else
      {
	// Scale the dimensions down by dispScale, rounding up
	sprNUON->w =
	  ( sprNUON->w >> dispScale ) + ( ( sprNUON->w & ( ( 1 << dispScale ) - 1 ) ) ? 1 : 0 );
	sprNUON->h =
	  ( sprNUON->h >> dispScale ) + ( ( sprNUON->h & ( ( 1 << dispScale ) - 1 ) ) ? 1 : 0 );
      }
    }    
  }
  
  if ( ( sp->attribute & SP_HINT_STICKY ) != 0 )
  {
    //    printf( "Returning sprite pointer due to sticky: %08X\n", sprNUON );
    retVal = sprNUON;
  }

  return retVal;
}

// =================================================================================================

SPRITE* GsSortSprite(GsSPRITE * sp, GsOT * ot, unsigned short pri)
{
  SPRITE *retVal = NULL;

  // Only continue if the sprite is supposed to be displayed
  if ( ( sp->attribute & ( 1 << 31 ) ) == 0 )
  {
    retVal = SortSprite( sp, ot, pri, FALSE );
  }

  return retVal;
}

// =================================================================================================

SPRITE* GsSortFastSprite(GsSPRITE * sp, GsOT * ot, unsigned short pri)
{
  SPRITE *retVal = NULL;

  // Only continue if the sprite is supposed to be displayed
  if ( ( sp->attribute & ( 1 << 31 ) ) == 0 )
  {
    retVal = SortSprite( sp, ot, pri, TRUE );
  }

  return retVal;
}

// =================================================================================================

void    GsInitFixBg16(GsBG * bg, u_long * work)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void    GsSortFixBg16(GsBG * bg, u_long * work, GsOT * otp, unsigned short pri)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void yarSortLine( int x0, int y0, int x1, int y1, int r, int g, int b, GsOT *ot, unsigned short pri, int flags)
{
  unsigned char _y, cr, cb;
  unsigned long color;
  
  _y = r;
  cr = g;
  cb = b;

  rgb2ycrcb(&_y, &cr, &cb);

  color = (_y << 24) | (cr << 16) | (cb << 8);

  SPRAddLine( x0, y0, x1, y1, color, color, 0xFFFF - pri, yarGetOTIndex( ot ), flags );
}

// =================================================================================================

void yarSortLineYCrCb( int x0, int y0, int x1, int y1, int color, GsOT *ot, unsigned short pri, int flags )
{
  SPRAddLine( x0, y0, x1, y1, color, color, 0xFFFF - pri, yarGetOTIndex( ot ), flags );
}

// =================================================================================================

void yarSortGLine(int x0, int y0, int x1, int y1, int r1, int g1, int b1, int r2, int g2, int b2,
		  GsOT *ot, unsigned short pri, int flags )
{
  unsigned char _y, cr, cb;
  unsigned long color1, color2;

  _y = r1;
  cr = g1;
  cb = b1;
  rgb2ycrcb( &_y, &cr, &cb );
  color1 = ( _y << 24 ) | ( cr << 16 ) | ( cb << 8 );
  
  _y = r2;
  cr = g2;
  cb = b2;
  rgb2ycrcb( &_y, &cr, &cb );
  color2 = ( _y << 24 ) | ( cr << 16 ) | ( cb << 8 );

  SPRAddLine( x0, y0, x1, y1, color1, color2, 0xFFFF - pri, yarGetOTIndex( ot ), flags );
}

// =================================================================================================

void yarSortGLineYCrCb(int x0, int y0, int x1, int y1, int color1, int color2,
		  GsOT *ot, unsigned short pri, int flags )
{
  SPRAddLine( x0, y0, x1, y1, color1, color2, 0xFFFF - pri, yarGetOTIndex( ot ), flags );
}

// =================================================================================================

void    GsSortLine(GsLINE * lp, GsOT * ot, unsigned short pri)
{
  SPRITE *sprNUON;
  
  // Quit if not supposed to be displayed
  if ( lp->attribute & (1<<31)) return;

  // If using SPEEDSCALE be sure to only draw sprites the last iteration
  if ( _frame != 0 ) return;
  
  sprNUON = getNUONLine(lp, &constWhiteImg, ot, pri);

  if ( sprNUON) {
    sprNUON->x >>= dispScale;
    sprNUON->y >>= dispScale;
#ifdef USE_BORDERX
    if ( !vcOtherRender) {
      sprNUON->x += borderX;
    }
#endif
    sprNUON->xscale >>= dispScale;
    sprNUON->yscale >>= dispScale;
  }
}

// =================================================================================================

void    GsSortGLine(GsGLINE * lp, GsOT * ot, unsigned short pri)
{
  //  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
  GsLINE newline;

  newline.attribute = lp->attribute;
  newline.x0 = lp->x0;
  newline.y0 = lp->y0;
  newline.x1 = lp->x1;
  newline.y1 = lp->y1;
  newline.r = (lp->r0 + lp->r1) >> 1;
  newline.g = (lp->g0 + lp->g1) >> 1;
  newline.b = (lp->b0 + lp->b1) >> 1;
  
  GsSortLine(&newline, ot, pri);
}

// =================================================================================================

void    GsSortBoxFill(GsBOXF * bp, GsOT * ot, unsigned short pri)
{
  SPRITE *sprNUON;
  
  // Quit if not supposed to be displayed
  if ( bp->attribute & ( 1 << 31 ) )
  {
    return;
  }

  // If using SPEEDSCALE be sure to only draw sprites the last iteration
  if ( _frame != 0 )
  {
    return;
  }

  //  printf("Box\n");
  sprNUON = getNUONBox(bp, &constWhiteImg, ot, pri);

  if ( sprNUON != NULL )
  {
    sprNUON->x >>= dispScale;
    sprNUON->y >>= dispScale;
#ifdef USE_BORDERX
    if ( vcOtherRender == FALSE )
    {
      sprNUON->x += borderX;
    }
#endif
    sprNUON->xscale >>= dispScale;
    sprNUON->yscale >>= dispScale;
  }
}

// =================================================================================================

void    GsClearOt(unsigned short offset, unsigned short point, GsOT * otp)
{
  int otIndex = yarGetOTIndex(otp);
  int debug = FUNC_TRACE;
  
  //  SPRReset(yarGetOTIndex(otp));
  if ( debug != 0 ) printf("YARLIB GsClearOt(): ot=%08X (%d)\n", otp, otIndex);
  SPRClearDisplayList(otIndex);
  aOT[otIndex] = NULL;     // remove it from the list of active OTs so we can reuse the slot
  numSprites = 0;

  perfEventLog(kEventClearOT, otIndex, 0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF);
}

// =================================================================================================

GsOT   *GsSortOt(GsOT * ot_src, GsOT * ot_dest)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void GsDefDispBuff(unsigned short x0, unsigned short y0, unsigned short x1, unsigned short y1)
{
  allocateFrameBuffers( bufferW, bufferH, x0, y0, x1, y1 );

  // Store locations of frame buffers in yaroze vram
  //  fbX[0] = x0;
  //  fbY[0] = y0;
  //  fbX[1] = x1;
  //  fbY[1] = y1;

  
}

// =================================================================================================

void GetTimInfoLittleEndian(unsigned long *tim, GsIMAGE *img)
{
  unsigned char *ptr = (char *) tim;
  int clutSize;
  int pixelSize;
  int i;
  
  ptr -= 4;

  tim[-1] = ptr[0] | (ptr[1] << 8) | (ptr[2] << 16) | (ptr[3] << 24);  ptr += 4;

  tim[0] = ptr[0] | (ptr[1] << 8) | (ptr[2] << 16) | (ptr[3] << 24);  ptr += 4;
  img->pmode = tim[0] & 0xF;

  if ( tim[0] & (1<<3)) {
    tim[1] = ptr[0] | (ptr[1] << 8) | (ptr[2] << 16) | (ptr[3] << 24);  ptr += 4;
    clutSize = tim[1];

    tim[2] = ptr[0] | (ptr[1] << 8) | (ptr[2] << 16) | (ptr[3] << 24);  ptr += 4;
    img->cx = (tim[2] >>  0) & 0xFFFF;
    img->cy = (tim[2] >> 16) & 0xFFFF;

    tim[3] = ptr[0] | (ptr[1] << 8) | (ptr[2] << 16) | (ptr[3] << 24);  ptr += 4;
    img->cw = (tim[3] >>  0) & 0xFFFF;
    img->ch = (tim[3] >> 16) & 0xFFFF;

    img->clut = &tim[4];
    for (i = 0; i < ((clutSize - 12) >> 2); i++) {
      //      tim[4 + i] = ptr[0] | (ptr[1] << 8) | (ptr[2] << 16) | (ptr[3] << 24);
      ptr += 4;
    }

  } else {
    clutSize = 0;
  }

  clutSize >>= 2;
  tim[1 + clutSize + 0] = ptr[0] | (ptr[1] << 8) | (ptr[2] << 16) | (ptr[3] << 24);  ptr += 4;
  pixelSize = tim[1 + clutSize + 0];

  tim[1 + clutSize + 1] = ptr[0] | (ptr[1] << 8) | (ptr[2] << 16) | (ptr[3] << 24);  ptr += 4;
  img->px = (tim[1 + clutSize + 1] >>  0) & 0xFFFF;
  img->py = (tim[1 + clutSize + 1] >> 16) & 0xFFFF;

  tim[1 + clutSize + 2] = ptr[0] | (ptr[1] << 8) | (ptr[2] << 16) | (ptr[3] << 24);  ptr += 4;
  img->pw = (tim[1 + clutSize + 2] >>  0) & 0xFFFF;
  img->ph = (tim[1 + clutSize + 2] >> 16) & 0xFFFF;

  img->pixel = &tim[1 + clutSize + 3];
  for (i = 0; i < ((pixelSize - 12) >> 2); i++) {
    if ( (tim[0] & 0x3) <= 0x1) {
      //    tim[1 + clutSize + 3 + i] = ptr[0] | (ptr[1] << 8) | (ptr[2] << 16) | (ptr[3] << 24);
      tim[1 + clutSize + 3 + i] = ptr[2] | (ptr[3] << 8) | (ptr[0] << 16) | (ptr[1] << 24);
    }
    ptr += 4;
  }

  _DCacheSync();
}

// =================================================================================================

void GsGetTimInfo(unsigned long *tim, GsIMAGE *img)
{
  int clutSize;

  // If ID is wrong endinness convert the whole file
  if ( tim[-1] == 0x10000000) return(GetTimInfoLittleEndian(tim, img));

  img->pmode = tim[0] & 0xF;

  // Read CLUT if TIM has one
  if ( tim[0] & (1<<3)) {
    clutSize = tim[1] >> 2;
    img->cx = (tim[2] >>  0) & 0xFFFF;
    img->cy = (tim[2] >> 16) & 0xFFFF;
    img->cw = (tim[3] >>  0) & 0xFFFF;
    img->ch = (tim[3] >> 16) & 0xFFFF;
    img->clut = &tim[4];

  } else {
    clutSize = 0;
  }

  img->px = (tim[1 + clutSize + 1] >>  0) & 0xFFFF;
  img->py = (tim[1 + clutSize + 1] >> 16) & 0xFFFF;
  img->pw = (tim[1 + clutSize + 2] >>  0) & 0xFFFF;
  img->ph = (tim[1 + clutSize + 2] >> 16) & 0xFFFF;
  img->pixel = &tim[1 + clutSize + 3];
}

// =================================================================================================

void GsSwapDispBuff(void)
{
  int debug = FUNC_TRACE;
  unsigned char r, g, b;
  
  // Set the video to point at the drawn buffer
  if ( vcYar.base != yarozeBuff )
  {
    if ( devSystem && ( _Controller[1].buttons & JOY_NUON ) &&
	( curButtons & JOY_C_DOWN ) && ( ( prevButtons & JOY_C_DOWN ) == 0 ) )
    {
      showFramerate = 1 - showFramerate;
      printf( "YARLIB: Framerate is now %s\n", showFramerate ? "ON" : "OFF" );
    }
  
    if ( showFramerate != 0 )
    {
      int x, y, i;
      
      x = 30;
      y = 20;
      i = lastfps;

      YarFillRect( x-1, y-1, 1+5*6+9*4+1, 1+4+1, YCrCb32_DARK_BLUE, aFBIndex[drawBuffer] );
      //      if ( lastfps == (60 / maxFrameRate)) {
      if ( lastfps == maxFrameRate )
      {
	/*
	while (i >= 10) {
	  YarFillRect(x, y, 4, 4, YCrCb32_LIGHT_YELLOW, aFBIndex[drawBuffer]);
	  x += 6;
	  i -= 10;
	}
	*/
	YarFillRect( x, y, 24, 4, YCrCb32_LIGHT_YELLOW, aFBIndex[drawBuffer] );
	x += 26;
	for (i = extraTime / 1000; i; i-- )
	{
	  YarFillRect( x, y, 4, 4, YCrCb32_LIGHT_GREEN, aFBIndex[drawBuffer] );
	  x += 6;
	}
      }
      else
      {
	while ( i >= 10 )
	{
	  YarFillRect( x, y, 4, 4, YCrCb32_LIGHT_RED, aFBIndex[drawBuffer] );
	  x += 6;
	  i -= 10;
	}
	while ( i > 0 )
	{
	  YarFillRect( x, y+1, 2, 2, YCrCb32_LIGHT_BLUE, aFBIndex[drawBuffer] );
	  x += 4;
	  i--;
	}
      }
    }

    // Do _VidConfig rather than _VidChangeBase because the other channel might have changed too
    //    vcYar.base = aFB[aFBIndex[drawBuffer]].ptr;
    //    if ( debug != 0 ) printf("YARLIB GsSwapDispBuff(): New FB base=%08X\n", vcYar.base);
    //    _VidConfig(&vd, vcMain, vcOSD, 0L);
  }

  buffReady++;

  prevBuffer = drawBuffer;
  drawBuffer++;
  if ( drawBuffer >= numFB )
  {
    drawBuffer = 0;
  }
  if ( numFB == DOUBLE_BUFFER )
  {
    dispBuffer++;
    if ( dispBuffer >= numFB )
    {
      dispBuffer = 0;
    }
    
    vcYar.base = aFB[aFBIndex[dispBuffer]].ptr;
    _VidConfig( &vd, vcMain, vcOSD, 0L );
  }

  perfEventLog( kEventSwapDispBuff, buffReady, buffDisp, drawBuffer, dispBuffer );
      
  if ( debug != 0 )
  {
    printf( "YARLIB GsSwapDispBuff(): drawBuffer=%d(FB=%d)  dispBuffer=%d(FB=%d)\n",
	    drawBuffer, aFBIndex[drawBuffer], dispBuffer, aFBIndex[dispBuffer] );
  }
  
  if ( numFB == QUAD_BUFFER )
  {
    // Wait for a buffer to be available so we can draw into it
    while ( drawBuffer == dispBuffer ) { }
  }

  // If the isbg field is set in GsDRAWENV then we automatically clear to the given color
  if ( ( GsDRAWENV.isbg == 1 ) && ( clrScreen == 0 ) )
  {
    clrScreen = TRUE;
    clrMethod = kClearColor;
    r = GsDRAWENV.r0;
    g = GsDRAWENV.g0;
    b = GsDRAWENV.b0;
    rgb2ycrcb( &r, &g, &b );
    clrParam1 = ( r << 24 ) | ( g << 16 ) | ( b << 8 );
  }

  //  SPRReset();
}

// =================================================================================================

int     GsGetActiveBuff(void)
{
  perfEventLog(kEventGetActiveBuff, drawBuffer & 0x1, 0xFFFFFFFF,0xFFFFFFFF,0xFFFFFFFF);

  return (drawBuffer & 0x1);  // Mask out in case quad-buffering
}

// =================================================================================================

void    GsSetDrawBuffClip(void)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void    GsSetDrawBuffOffset(void)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void    GsSetClip(RECT * clip)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void    GsSetOffset(long x, long y)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void    GsSetOrign(long x, long y)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void    GsInitCoordinate2(GsCOORDINATE2 * super, GsCOORDINATE2 * base)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void    GsGetLw(GsCOORDINATE2 * m, MATRIX * out)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void    GsGetLs(GsCOORDINATE2 * m, MATRIX * out)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void    GsGetLws(GsCOORDINATE2 * m, MATRIX * outw, MATRIX * outs)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void    GsLinkObject4(unsigned long tmd_base, GsDOBJ2 * objp, int n)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void    GsSetLightMatrix(MATRIX * mp)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

int     GsSetRefView2(GsRVIEW2 * pv)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

int     GsSetView2(GsVIEW2 * pv)
{
}

// =================================================================================================

void    GsSetLsMatrix(MATRIX * mp)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void    GsSetClip2D(RECT * rectp)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

PACKET *GsGetWorkBase()
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void    GsSortClear(unsigned char r, unsigned char g , unsigned char b, GsOT *otp)
{
  int rTmp, gTmp, bTmp, aTmp = 0xFF;

  if ( clrScreen == FALSE )
  {
    clrScreen = TRUE;

    if ( screenFlash && !vcOtherRender)
    {
      // Get alpha first
      aTmp -= screenFlash;
      if ( aTmp < 0) aTmp = 0;

      // Add the flash factoring in alpha so that it looks correct
      rTmp = r + (screenFlash<<8) / (0x100 - aTmp);
      gTmp = g + (screenFlash<<8) / (0x100 - aTmp);
      bTmp = b + (screenFlash<<8) / (0x100 - aTmp);
      if ( rTmp > 0xFF) rTmp = 0xFF;
      if ( gTmp > 0xFF) gTmp = 0xFF;
      if ( bTmp > 0xFF) bTmp = 0xFF;
      r = (unsigned char) rTmp;
      g = (unsigned char) gTmp;
      b = (unsigned char) bTmp;
    }
    rgb2ycrcb(&r, &g, &b);
    //  clrColor = (r << 24) | (g << 16) | (b << 8);
    clrParam1 = (r << 24) | (g << 16) | (b << 8) | 0x7E;
    if ( yarChannel == VID_CHANNEL_OSD) clrParam1 |= aTmp;  // make all non-drawn pixels transparent

    clrMethod = kClearColor;
  }
}

// =================================================================================================

void    GsScaleScreen(SVECTOR * scale)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

MATRIX *MulMatrix0(MATRIX *m0, MATRIX *m1, MATRIX *m2)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

VECTOR *ApplyMatrix(MATRIX *m, SVECTOR *v0, VECTOR *v1)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

VECTOR *ApplyMatrixSV(MATRIX *m, SVECTOR *v0, SVECTOR *v1)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

VECTOR *ApplyMatrixLV(MATRIX *m, VECTOR *v0, VECTOR *v1)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

MATRIX *RotMatrix(SVECTOR *r, MATRIX *m)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

MATRIX *RotMatrixX(long r, MATRIX *m)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

MATRIX *RotMatrixY(long r, MATRIX *m)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

MATRIX *RotMatrixZ(long r, MATRIX *m)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

MATRIX *TransMatrix(MATRIX *m,VECTOR *v)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

MATRIX *ScaleMatrix(MATRIX *m,VECTOR *v)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

MATRIX *ScaleMatrixL(MATRIX *m,VECTOR *v)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

MATRIX *TransposeMatrix(MATRIX *m0, MATRIX *m1)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

MATRIX *CompMatrix(MATRIX *m0, MATRIX *m1, MATRIX *m2)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void PushMatrix()
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void PopMatrix()
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void gteMIMefunc(SVECTOR *otp, SVECTOR *dfp, long n, long p)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================


// Sound Functions
void  SsVabClose (short vab_id)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

short SsVabTransfer (unsigned char *vh_addr, unsigned char *vb_addr,
		     short vabid, short i_flag)
{
  int i;
  short retVal = -1;
  static short nextVabID = 0;
  int inc = 0;

  if ( aSndMap == NULL) {
    return;
  }

  for (i = 0; aSndMap[i].vb; i++) {

    if ( aSndMap[i].vb == vb_addr) {
      if ( vabid == -1) {
	retVal = aSndMap[i].vabID = nextVabID;
	inc = 1;
      }
    }
  }

  if ( inc) {
    nextVabID++;
  }

  return retVal;
}

// =================================================================================================

short SsSeqOpen (unsigned long *addr, short vab_id)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsSeqClose (short seq_access_num)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsSeqPlay (short seq_access_num, char play_mode, short l_count)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsSeqPause (short seq_access_num)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsSeqReplay (short seq_access_num)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsSeqStop (short seq_access_num)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsSeqSetVol (short seq_access_num, short vall, short volr)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsSeqGetVol (short seq_access_num, short seq_num, short *voll,
		   short *volr)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsSeqSetNext (short seq_access_num1, short seq_access_num2)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsSeqSetRitardando (short seq_access_num, long tempo, long v_time)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsSeqSetAccelerando (short seq_access_num, long tempo, long v_time)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsSetMVol (short voll, short volr)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsGetMVol (SndVolume *m_vol)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsSetMute (char mode)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

char  SsGetMute (void)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsSetTempo (short access_num, short seq_num, short tempo)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

short SsIsEos (short access_num, short seq_num)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsPlayBack (short access_num, short seq_num, short l_count)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsSetSerialAttr (char s_num, char attr, char mode)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

char  SsGetSerialAttr (char s_num, char attr)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsSetSerialVol (char s_num, short voll, short volr)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsGetSerialVol (char s_num, SndVolume *s_vol)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

short SsUtKeyOn (short vabId, short prog, short tone, short note, short fine,
		 short voll, short volr)
{
  int i = 0;
  PCMPOS pan;

  if ( aSndMap == NULL) {
    return -1;
  }

  while (aSndMap[i].vb) {
    if ( (aSndMap[i].vabID   == vabId) &&
	(aSndMap[i].progNum == prog ) &&
	(aSndMap[i].toneNum == tone )) {
      pan.PCMPanLR  = 0;
      pan.PCMPanFB  = 0;
      pan.PCMPanUD  = 0;
      pan.Reserved1 = 0;
      return PlayWAV(aSndMap[i].wave, -1, &pan, voll << 23, note);  //Yaroze Vol=0.16  NUON Vol=1.31
    }
    i++;
  }
}

// =================================================================================================

short SsUtKeyOff (short voice, short vabId, short prog, short tone, short note)
{
  PCMVoiceOff(voice);

  return 0;
}

// =================================================================================================

short SsUtPitchBend (short voice, short vabId, short prog, short note,
		     short pbend)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

short SsUtChangePitch (short voice, short vabId, short prog, short old_note,
		       short old_fine, short new_note, short new_fine)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

short SsUtSetVVol (short vc, short voll, short volr)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

short SsUtGetVVol (short vc, short *voll, short *volr)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsUtReverbOn (void)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsUtReverbOff (void)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

short SsUtSetReverbType (short type)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

short SsUtGetReverbType (void)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsUtSetReverbDepth (short ldepth, short rdepth)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsUtSetReverbFeedback (short feedback)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsUtSetReverbDelay (short delay)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void  SsUtAllKeyOff (short mode)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

/*
// Mathematical Functions
double pow(double x, double y)
{
}

// =================================================================================================

double exp(double x)
{
}

// =================================================================================================

double log(double x)
{
}

// =================================================================================================

double log10(double x)
{
}

// =================================================================================================

double floor(double x)
{
}

// =================================================================================================

double ceil(double x)
{
}

// =================================================================================================

double fmod(double x, double y)
{
}

// =================================================================================================

double modf(double x, double *y)
{
}

// =================================================================================================

double sin(double x)
{
}

// =================================================================================================

double cos(double x)
{
}

// =================================================================================================

double tan(double x)
{
}

// =================================================================================================

double asin(double x)
{
}

// =================================================================================================

double acos(double x)
{
}

// =================================================================================================

double atan(double x)
{
}

// =================================================================================================

double atan2(double x, double y)
{
}

// =================================================================================================

double sinh(double x)
{
}

// =================================================================================================

double cosh(double x)
{
}

// =================================================================================================

double tanh(double x)
{
}

// =================================================================================================

double sqrt(double x)
{
}

// =================================================================================================

double hypot(double x, double y)
{
}

// =================================================================================================

double ldexp(double x, int n)
{
}

// =================================================================================================

double frexp(double x, int *n)
{
}

// =================================================================================================

double atof(char *s)
{
}

// =================================================================================================

double strtod(char *s, char **endp)
{
}

// =================================================================================================

int printf2(char *fmt, ...)
{
}

// =================================================================================================

int sprintf2(char *s, char *fmt, ...)
{
}
*/

// =================================================================================================


// Miscellaneous Functions
void GetPadBuf(volatile unsigned char **buf1, volatile unsigned char **buf2)
{
  // Dual-shock has 8 bytes of data
  // Technically the maximum is 2 + 32 bytes (according to the Yaroze docs),
  // but what controller would send that much?
  *buf1 = (unsigned char *) &yarPad[0];
  *buf2 = (unsigned char *) &yarPad[1];

  readControllers();
}

// =================================================================================================

long GetRCnt(unsigned long spec)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

long ResetRCnt(unsigned long spec)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

long StartRCnt(unsigned long spec)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================
/*
int open(char *devname, int flag)
{
}

// =================================================================================================

int close(int fd)
{
}

// =================================================================================================

long ioctl(long, long, long)
{
}

// =================================================================================================

int lseek(int fd, unsigned int offset, int flag)
{
}

// =================================================================================================

int read(int fd, char *buf, int n)
{
}

// =================================================================================================

int write(int fd, char *buf, int n)
{
}

// =================================================================================================

struct DIRENTRY * firstfile(char *name, struct DIRENTRY *dir)
{
}

// =================================================================================================

struct DIRENTRY * nextfile(struct DIRENTRY *dir)
{
}

// =================================================================================================

int delete(char *name)
{
}

// =================================================================================================

int format(char *fs)
{
}

// =================================================================================================

int rename(char *src, char *dest)
{
}

// =================================================================================================

long LoadTest(char *name, struct EXEC *exec)
{
}

// =================================================================================================

long Load(char *name, struct EXEC *exec)
{
}

// =================================================================================================

long Exec(struct EXEC *exec, long argc, char **argv)
{
}
*/
// =================================================================================================

void FlushCashe(void)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

long _get_errno(void)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

int CdReadFile(char *file, u_long *addr, int nbyte)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

int CdReadSync(int mode, u_char *result)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

CdlFILE *CdSearchFile(CdlFILE *fp, char *name)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

struct EXEC *CdReadExec(char *file)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

int CdPlay(int mode, int *tracks, int offset)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void EnterCriticalSection(void)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

void ExitCriticalSection(void)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

long TestCard(long chan)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

long GetVideoMode(void)
{
  if ( SHOW_UNIMPLEMENTED_FUNCTIONS) printf("\nYARLIB ERROR: %s not implemented\n", __func__);
}

// =================================================================================================

long SetVideoMode(long mode)
{
  // Does nothing in NUON environment
}


